import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.CookieHandler;
import java.net.URL;
import java.net.URLConnection;
import java.text.Collator;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import klaue.DownloadHelper.ListCookieHandler;
import DownloadHelpers.WrongUsernameOrPasswordException;
import Helpers.Account;
import Helpers.Builder;
import Helpers.Crypter;
import Helpers.Dictionary;
import Helpers.ErrorLogger;
import Helpers.Grabbable;
import Helpers.GrabberImage;
import Helpers.Logwriter;
import Helpers.ProgressMonitor;
import Helpers.ProgressUtil;
import Helpers.ProxyDialog;
import Sites.DeviantArt;
import Sites.DeviantArtFavs;
import Sites.Fchan;
import Sites.FurAffinity;
import Sites.VCL;

@SuppressWarnings("serial")
public class GalleryGrabber extends JFrame {
	Dictionary DICT = Dictionary.getInstance();
	
	static final String PATH_OF_404_IMG = "Workfiles/user_not_found.jpg";
	static final String LOGO = "Workfiles/logo.jpg";
	static final String IMAGEDIR = "Workfiles/Downloaded_Images";
	static final String HTMLFOLDER = "HTML_Files";
	static final String SAVEFILENAME = "Workfiles/accounts.sve";
	static final String SAVEBACKUP = "Workfiles/b/accounts.sve";
	final GalleryGrabber ownFrame = this;
	
	static final String FRAMESET_PGE = "frameset.html";
	static final String NAVI_PGE = "navigation.html";
	static final String START_PGE = "logo.html";
	static final String ALL_PGE = "ALL";
	static final String TARGET_NAME = "right";
	static final String FRAMESET_COLS = "230,*";
	// Flash include mainly stolen from youtube (should work with any browser). replace XXXXXXXX with the swf path
	static final String FLASH_INCLUDE = "<object width=\"425\" height=\"344\"><param name=\"movie\" value=\"XXXXXXXX\">" +
				"</param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"allowscriptaccess\" value=\"always\">" +
				"</param><embed src=\"XXXXXXXX\" type=\"application/x-shockwave-flash\" allowscriptaccess=\"always\" " +
				"allowfullscreen=\"true\" width=\"425\" height=\"344\"></embed></object>";
	final String[] FRAMESET = {"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Frameset//EN\"",
			"\t\"http://www.w3.org/TR/html4/frameset.dtd\">", "<html>", "<head>",
			"<title>GalleryGrabber by Klaue</title>","</head>", "<frameset cols=\"" + FRAMESET_COLS + "\">",
			"\t<frame src=\"" + NAVI_PGE + "\" name=\"Navigation\">",
			"\t<frame src=\"" + START_PGE + "\" name=\"" + TARGET_NAME + "\">", "\t<noframes>",
			"\t\t<body>", "\t\t\t<h2>" + this.DICT.getValue("NoFrameset") + "</h2>", "\t\t</body>",
			"\t</noframes>", "</frameset>", "</html>"};
	static final String[] PAGEHEADER = {"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">",
			"<html>", "\t<head>", "\t<title>GalleryGrabber</title>", "\t</head>", "\t<body>"};
	static final String[] PAGEFOOTER = {"\t</body>", "</html>"};
	static final String[] START = {"\t\t<img src=\"%LOGOPATH%\" alt=\"\"><br><br><br><br>"};
	
	// all aviable sites (for accountbuilder/copier, run function)
	Vector<Grabbable> vSites = new Vector<Grabbable>();
	
	// all accounts. first string: pagename. second string: accountname
	TreeMap<String, TreeMap<String, Account>> mAccountMap = new TreeMap<String, TreeMap<String, Account>>();
	
	// proxy values
	TreeMap<String, String> mProxyMap = new TreeMap<String, String>();
	
	// boolean to prevent saving while loading
	boolean bLoadingInProgress = false;
	
	JFrame own = this;
	
	JButton btnNewAccount;
	JButton btnModifyAccount;
	JButton btnCopyAccount;
	JButton btnDeleteAccount;
	JButton btnGo;
	JButton btnProxy;
	
	
	JList lstSites;
	DefaultListModel mdlSites;
	JList lstAccounts;
	DefaultListModel mdlAccounts;
	
	JLabel lblSites;
	JLabel lblAccounts;
	JLabel lblImagesSince;
	JLabel lblCheck;
	JLabel lblChangeLanguage;
	JLabel lblImgPerSite;

	JCheckBox chkUseProxy;
	JCheckBox chkEmbedFlash;
	JCheckBox chkDelOld;
	
	JRadioButton rbtLastDownload;
	JRadioButton rbtDate;
	JRadioButton rbtAccount;
	JRadioButton rbtPage;
	JRadioButton rbtAll;
	
	ButtonGroup bgrImagesSince;
	ButtonGroup bgrCheck;
	
	DateComboBox dcbDate;
	
	JComboBox cbxLanguage;
	
	JTextField jtfImagesPerPage;
	
	JPanel pnlAll;
	JPanel pnlSites;
	JPanel pnlAccounts;
	JPanel pnlOptions;
	JPanel pnlChangeLang;
	JPanel pnlChangeImgPerPage;
	JPanel pnlProxy;
	JPanel pnlRun;
	
	public GalleryGrabber() {
		CookieHandler.setDefault(new ListCookieHandler());
		initialize();
		load();
		setSize(new Dimension(700, 400));
		setLocationRelativeTo(null); // center frame
	    setTitle("GalleryGrabber 1.6");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
		//System.setProperty("proxyPort","8118");
		//System.setProperty("proxyHost","localhost");
	}
	
	private void initialize() {
		this.vSites.add(new DeviantArt());
		this.vSites.add(new DeviantArtFavs());
		this.vSites.add(new Fchan());
		this.vSites.add(new FurAffinity());
		this.vSites.add(new VCL());
		//vSites.add(new SoFurry());
		
		this.mProxyMap.put("http.proxyHost", "");
		this.mProxyMap.put("http.proxyPort", "");
		this.mProxyMap.put("http.proxyUser", "");
		this.mProxyMap.put("http.proxyPassword", "");
		
		// Buttons
		this.btnNewAccount = new JButton(this.DICT.getValue("btnNewAccount"));
		// use full aviable width
		this.btnNewAccount.setMaximumSize(new Dimension(1000, this.btnNewAccount.getMaximumSize().height));
		this.btnNewAccount.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Builder builder = new Builder(GalleryGrabber.this.vSites, GalleryGrabber.this.mAccountMap, GalleryGrabber.this.ownFrame);
				builder.displayBuilder();
				ArrayList<Account> accounts = builder.getAccounts();
				// wenn nicht abgebrochen
				if (!accounts.isEmpty()) {
					for (Account acc : accounts) addAccount(acc);
				}
				save();
			}
		});
		
		this.btnModifyAccount = new JButton(this.DICT.getValue("btnModifyAccount"));
		// use full aviable width
		this.btnModifyAccount.setMaximumSize(new Dimension(1000, this.btnModifyAccount.getMaximumSize().height));
		this.btnModifyAccount.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Builder builder = new Builder(GalleryGrabber.this.vSites, GalleryGrabber.this.mAccountMap, GalleryGrabber.this.ownFrame);
				builder.displayChanger(GalleryGrabber.this.mAccountMap.get(GalleryGrabber.this.lstSites.getSelectedValue()).get(GalleryGrabber.this.lstAccounts.getSelectedValue()));
				ArrayList<Account> account = builder.getAccounts();
				// wenn nicht abgebrochen
				if (!account.isEmpty()) {
					Account acc = account.get(0);
					GalleryGrabber.this.mAccountMap.get(GalleryGrabber.this.lstSites.getSelectedValue()).remove(GalleryGrabber.this.lstAccounts.getSelectedValue());
					if (GalleryGrabber.this.mAccountMap.get(GalleryGrabber.this.lstSites.getSelectedValue()).isEmpty()) {
						GalleryGrabber.this.mAccountMap.remove(GalleryGrabber.this.lstSites.getSelectedValue());
						GalleryGrabber.this.mdlSites.removeElement(GalleryGrabber.this.lstSites.getSelectedValue());
					}
					
					if (GalleryGrabber.this.mAccountMap.get(acc.PageName) != null) {
						GalleryGrabber.this.mAccountMap.get(acc.PageName).put(acc.TargetUser, acc);
					} else {
						TreeMap<String, Account> blamap = new TreeMap<String, Account>();
						blamap.put(acc.TargetUser, acc);
						GalleryGrabber.this.mAccountMap.put(acc.PageName, blamap);
						GalleryGrabber.this.mdlSites.addElement(acc.PageName);
					}
					
					// just to renew the lstAccounts and unset the copy-account-button
					GalleryGrabber.this.lstSites.revalidate();
					GalleryGrabber.this.lstSites.clearSelection();
					GalleryGrabber.this.lstSites.setSelectedValue(acc.PageName, true);
					GalleryGrabber.this.lstAccounts.setSelectedValue(acc.TargetUser, true);
					//addAccount(builder.getAccount());
				}
				save();
			}
		});
		
		this.btnCopyAccount = new JButton(this.DICT.getValue("btnCopyAccount"));
		// use full aviable width
		this.btnCopyAccount.setMaximumSize(new Dimension(1000, this.btnCopyAccount.getMaximumSize().height));
		this.btnCopyAccount.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Builder builder = new Builder(GalleryGrabber.this.vSites, GalleryGrabber.this.mAccountMap, GalleryGrabber.this.ownFrame);
				builder.displayCopier(GalleryGrabber.this.mAccountMap.get(GalleryGrabber.this.lstSites.getSelectedValue()).get(GalleryGrabber.this.lstAccounts.getSelectedValue()));
				ArrayList<Account> accounts = builder.getAccounts();
				// wenn nicht abgebrochen
				if (!accounts.isEmpty()) {
					for (Account acc : accounts) addAccount(acc);
				}
				save();
			}
		});
		
		this.btnDeleteAccount = new JButton(this.DICT.getValue("btnDeleteAccount"));
		// use full aviable width
		this.btnDeleteAccount.setMaximumSize(new Dimension(1000, this.btnDeleteAccount.getMaximumSize().height));
		this.btnDeleteAccount.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int answer = JOptionPane.showConfirmDialog(GalleryGrabber.this.ownFrame, GalleryGrabber.this.DICT.getValue("DeleteConfirmText"),
						GalleryGrabber.this.DICT.getValue("DeleteConfirmTitle"), JOptionPane.YES_NO_OPTION);
				// wenn nein oder cancel gew�hlt
				if (answer != JOptionPane.YES_OPTION) return;				
				// l�schen des eintrages aus der map
				TreeMap<String, Account> tmpMap = GalleryGrabber.this.mAccountMap.get(GalleryGrabber.this.lstSites.getSelectedValue());
				tmpMap.remove(GalleryGrabber.this.lstAccounts.getSelectedValue());
				if (tmpMap.size() == 0) GalleryGrabber.this.mAccountMap.remove(GalleryGrabber.this.lstSites.getSelectedValue());
				
				// l�schen der eintr�ge in den listen
				int index = GalleryGrabber.this.lstAccounts.getSelectedIndex();
				GalleryGrabber.this.mdlAccounts.removeElementAt(index);
				if (GalleryGrabber.this.mdlAccounts.getSize() == 0) {
					GalleryGrabber.this.btnDeleteAccount.setEnabled(false);
					GalleryGrabber.this.btnCopyAccount.setEnabled(false);
					GalleryGrabber.this.btnModifyAccount.setEnabled(false);
					
					index = GalleryGrabber.this.lstSites.getSelectedIndex();
					GalleryGrabber.this.mdlSites.removeElementAt(index);
					if (GalleryGrabber.this.mdlSites.getSize() != 0) {
						if (index == GalleryGrabber.this.mdlSites.getSize()) index -= 1;
						GalleryGrabber.this.lstSites.setSelectedIndex(index);
					}
				} else {
					// the deleted one was the last item
					if (index == GalleryGrabber.this.mdlAccounts.getSize()) index -= 1;
					GalleryGrabber.this.lstAccounts.setSelectedIndex(index);
				}
				save();
			}
		});
		
		
		this.btnGo = new JButton(this.DICT.getValue("btnGo"));
		// use full width and double the usual maximum and preferred height
		this.btnGo.setMaximumSize(new Dimension(100, this.btnGo.getMaximumSize().height * 2));
		this.btnGo.setAlignmentX(CENTER_ALIGNMENT);
		this.btnGo.setPreferredSize(new Dimension(100, this.btnGo.getPreferredSize().height * 2));
		this.btnGo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				GalleryGrabber.this.btnGo.setEnabled(false);
				Task task = new Task();
				new Thread(task).start(); 
			}
		});
		
		this.btnProxy = new JButton(this.DICT.getValue("btnProxy"));
		this.btnProxy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ProxyDialog proxy = new ProxyDialog(GalleryGrabber.this.ownFrame, GalleryGrabber.this.mProxyMap);
				proxy.showDialog();
				// wenn nicht abgebrochen
				if (proxy.getProperties() != null) {
					GalleryGrabber.this.mProxyMap = proxy.getProperties();
					if (GalleryGrabber.this.chkUseProxy.isSelected()) {
						if (!GalleryGrabber.this.mProxyMap.get("http.proxyHost").equals("") && !GalleryGrabber.this.mProxyMap.get("http.proxyPort").equals("")) {
							System.setProperty("http.proxyHost", GalleryGrabber.this.mProxyMap.get("http.proxyHost"));
							System.setProperty("http.proxyPort", GalleryGrabber.this.mProxyMap.get("http.proxyPort"));
							System.setProperty("https.proxyHost", GalleryGrabber.this.mProxyMap.get("http.proxyHost"));
							System.setProperty("https.proxyPort", GalleryGrabber.this.mProxyMap.get("http.proxyPort"));
							System.setProperty("http.nonProxyHosts", "localhost");
							if (!GalleryGrabber.this.mProxyMap.get("http.proxyUser").equals("") && !GalleryGrabber.this.mProxyMap.get("http.proxyPassword").equals("")) {
								System.setProperty("http.proxyUser", GalleryGrabber.this.mProxyMap.get("http.proxyUser"));
								System.setProperty("http.proxyPassword", GalleryGrabber.this.mProxyMap.get("http.proxyPassword"));
								System.setProperty("https.proxyUser", GalleryGrabber.this.mProxyMap.get("http.proxyUser"));
								System.setProperty("https.proxyPassword", GalleryGrabber.this.mProxyMap.get("http.proxyPassword"));
							}
						}
					}
				}
				save();
			}
		});
		
		//Lists
		this.mdlSites = new DefaultListModel();
		this.lstSites = new JList(this.mdlSites);
		this.lstSites.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		this.lstSites.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent arg0) {
				// list empty... do nothing else than setEnabled
				if (GalleryGrabber.this.lstSites.getComponentCount() == 0) {
					GalleryGrabber.this.rbtAll.setEnabled(false);
					GalleryGrabber.this.btnGo.setEnabled(false);
					return;
				}
				//clearSelection called... do nothing else than setEnabled
				if (GalleryGrabber.this.lstSites.getSelectedIndex() == -1) {
					GalleryGrabber.this.rbtPage.setEnabled(false);
					GalleryGrabber.this.btnGo.setEnabled(false);
					return;
				}
				GalleryGrabber.this.rbtPage.setEnabled(true);
				GalleryGrabber.this.rbtAll.setEnabled(true);
				
				// clear list to refill it
				GalleryGrabber.this.mdlAccounts.clear();
				TreeMap<String, Account> tmpMap = GalleryGrabber.this.mAccountMap.get(GalleryGrabber.this.lstSites.getSelectedValue());
				Iterator<String> iter = tmpMap.keySet().iterator();
				while(iter.hasNext()) {
					// no sorting because, well, maps are sorted ;)
					GalleryGrabber.this.mdlAccounts.addElement(iter.next());
				}
				GalleryGrabber.this.lstAccounts.setSelectedIndex(0);
				
				if (GalleryGrabber.this.rbtAll.isSelected() || GalleryGrabber.this.rbtPage.isSelected()) GalleryGrabber.this.btnGo.setEnabled(true);
			}
		});
		this.mdlAccounts = new DefaultListModel();
		this.lstAccounts = new JList(this.mdlAccounts);
		this.lstAccounts.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		this.lstAccounts.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent arg0) {
				if(GalleryGrabber.this.lstAccounts.getSelectedIndex() == -1) {
					// no selection
					GalleryGrabber.this.btnCopyAccount.setEnabled(false);
					GalleryGrabber.this.btnModifyAccount.setEnabled(false);
					GalleryGrabber.this.btnDeleteAccount.setEnabled(false);
					GalleryGrabber.this.rbtAccount.setEnabled(false);
					if (GalleryGrabber.this.rbtAccount.isSelected()) {
						GalleryGrabber.this.btnGo.setEnabled(false);
					}
				} else {
					GalleryGrabber.this.btnCopyAccount.setEnabled(true);
					GalleryGrabber.this.btnModifyAccount.setEnabled(true);
					GalleryGrabber.this.btnDeleteAccount.setEnabled(true);
					GalleryGrabber.this.rbtAccount.setEnabled(true);
					GalleryGrabber.this.btnGo.setEnabled(true);
				}
			}
		});
		
		// Labels
		this.lblSites = new JLabel(this.DICT.getValue("lblSites"));
		this.lblAccounts = new JLabel(this.DICT.getValue("lblAccounts"));
		this.lblImagesSince = new JLabel(this.DICT.getValue("lblImagesSince"));
		this.lblCheck = new JLabel(this.DICT.getValue("lblCheck"));
		this.lblChangeLanguage = new JLabel(this.DICT.getValue("lblChangeLanguage"));
		this.lblImgPerSite = new JLabel(this.DICT.getValue("lblImgPerSite"));
		
		// CheckBoxes
		this.chkUseProxy = new JCheckBox(this.DICT.getValue("chkUseProxy"));
		this.chkUseProxy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(GalleryGrabber.this.chkUseProxy.isSelected()) {
					if (!GalleryGrabber.this.mProxyMap.get("http.proxyHost").equals("") && !GalleryGrabber.this.mProxyMap.get("http.proxyPort").equals("")) {
						System.out.println("proxy activated");
						Logwriter.getInstance().writeLine("proxy activated");
						System.setProperty("http.proxyHost", GalleryGrabber.this.mProxyMap.get("http.proxyHost"));
						System.setProperty("http.proxyPort", GalleryGrabber.this.mProxyMap.get("http.proxyPort"));
						System.setProperty("https.proxyHost", GalleryGrabber.this.mProxyMap.get("http.proxyHost"));
						System.setProperty("https.proxyPort", GalleryGrabber.this.mProxyMap.get("http.proxyPort"));
						System.setProperty("http.nonProxyHosts", "localhost");
						if (!GalleryGrabber.this.mProxyMap.get("http.proxyUser").equals("") && !GalleryGrabber.this.mProxyMap.get("http.proxyPassword").equals("")) {
							System.setProperty("http.proxyUser", GalleryGrabber.this.mProxyMap.get("http.proxyUser"));
							System.setProperty("http.proxyPassword", GalleryGrabber.this.mProxyMap.get("http.proxyPassword"));
							System.setProperty("https.proxyUser", GalleryGrabber.this.mProxyMap.get("http.proxyUser"));
							System.setProperty("https.proxyPassword", GalleryGrabber.this.mProxyMap.get("http.proxyPassword"));
						}
					}
				} else {
					System.setProperty("http.proxyHost", "");
					System.setProperty("http.proxyPort", "");
					System.setProperty("http.proxyUser", "");
					System.setProperty("http.proxyPassword", "");
				}
				save();
			}
		});
		
		this.chkEmbedFlash = new JCheckBox(this.DICT.getValue("chkEmbedFlash"));
		this.chkEmbedFlash.setSelected(true);
		this.chkEmbedFlash.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				save();
			}
		});
		
		this.chkDelOld = new JCheckBox(this.DICT.getValue("chkDelOld"));
		this.chkDelOld.setSelected(true);
		this.chkDelOld.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				save();
			}
		});
		
		// RadioButtons
		this.rbtLastDownload = new JRadioButton(this.DICT.getValue("rbtLastDownload"));
		this.rbtLastDownload.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(GalleryGrabber.this.rbtLastDownload.isSelected()) {
					GalleryGrabber.this.dcbDate.setEnabled(false);
				}
			}
		});
		this.rbtLastDownload.setSelected(true);
		
		this.rbtDate = new JRadioButton(this.DICT.getValue("rbtDate"));
		this.rbtDate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(GalleryGrabber.this.rbtDate.isSelected()) {
					GalleryGrabber.this.dcbDate.setEnabled(true);
				}
			}
		});
		
		this.rbtAccount = new JRadioButton(this.DICT.getValue("rbtAccount"));
		this.rbtAccount.setSelected(true);
		this.rbtPage = new JRadioButton(this.DICT.getValue("rbtPage"));
		this.rbtAll = new JRadioButton(this.DICT.getValue("rbtAll"));
		this.rbtAll.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (GalleryGrabber.this.rbtAll.isSelected() && GalleryGrabber.this.rbtAll.isEnabled()) GalleryGrabber.this.btnGo.setEnabled(true);
			}
		});
		
		
		// ButtonGroups
		this.bgrImagesSince = new ButtonGroup();
		this.bgrImagesSince.add(this.rbtLastDownload);
		this.bgrImagesSince.add(this.rbtDate);
		this.bgrCheck = new ButtonGroup();
		this.bgrCheck.add(this.rbtAccount);
		this.bgrCheck.add(this.rbtPage);
		this.bgrCheck.add(this.rbtAll);
		
		
		// DateComboBoxes
		this.dcbDate = new DateComboBox(new Date(), this.DICT.getValue("DateFormat"));
		this.dcbDate.setEditable(false);
		// should behave like the labels
		this.dcbDate.setMinimumSize(new JLabel(this.DICT.getValue("DateFormat") + "xxxx").getMinimumSize());
		this.dcbDate.setPreferredSize(new JLabel(this.DICT.getValue("DateFormat") + "xxxx").getPreferredSize());
		this.dcbDate.setMaximumSize(new JLabel(this.DICT.getValue("DateFormat") + "xxxx").getMaximumSize());
		this.dcbDate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (GalleryGrabber.this.dcbDate.getDate() != null) {
					if (GalleryGrabber.this.dcbDate.getDate().after(Calendar.getInstance().getTime())) {
						Calendar cal = Calendar.getInstance();
						Calendar tmp = Calendar.getInstance();
						cal.clear();
						// auf heutiges datum setzen
						cal.set(Calendar.YEAR, tmp.get(Calendar.YEAR));
						cal.set(Calendar.MONTH, tmp.get(Calendar.MONTH));
						cal.set(Calendar.DAY_OF_MONTH, tmp.get(Calendar.DAY_OF_MONTH));
						GalleryGrabber.this.dcbDate.setDate(cal.getTime());
					}
				}
			}
		});
		
		// ComboBoxes
		this.cbxLanguage = new JComboBox(this.DICT.getLanguages());
		this.cbxLanguage.setMinimumSize(new JLabel(this.DICT.getLanguage() + "xxxx").getMinimumSize());
		this.cbxLanguage.setPreferredSize(new JLabel(this.DICT.getLanguage() + "xxxx").getPreferredSize());
		this.cbxLanguage.setMaximumSize(new JLabel(this.DICT.getLanguage() + "xxxx").getMaximumSize());
		this.cbxLanguage.setSelectedItem(this.DICT.getLanguage());
		this.cbxLanguage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				GalleryGrabber.this.DICT.setLanguage((String)GalleryGrabber.this.cbxLanguage.getSelectedItem());
				GalleryGrabber.this.btnNewAccount.setText(GalleryGrabber.this.DICT.getValue("btnNewAccount"));
				GalleryGrabber.this.btnCopyAccount.setText(GalleryGrabber.this.DICT.getValue("btnCopyAccount"));
				GalleryGrabber.this.btnModifyAccount.setText(GalleryGrabber.this.DICT.getValue("btnModifyAccount"));
				GalleryGrabber.this.btnDeleteAccount.setText(GalleryGrabber.this.DICT.getValue("btnDeleteAccount"));
				GalleryGrabber.this.btnGo.setText(GalleryGrabber.this.DICT.getValue("btnGo"));
				GalleryGrabber.this.btnProxy.setText(GalleryGrabber.this.DICT.getValue("btnProxy"));
				GalleryGrabber.this.lblSites.setText(GalleryGrabber.this.DICT.getValue("lblSites"));
				GalleryGrabber.this.lblAccounts.setText(GalleryGrabber.this.DICT.getValue("lblAccounts"));
				GalleryGrabber.this.lblImagesSince.setText(GalleryGrabber.this.DICT.getValue("lblImagesSince"));
				GalleryGrabber.this.lblCheck.setText(GalleryGrabber.this.DICT.getValue("lblCheck"));
				GalleryGrabber.this.lblChangeLanguage.setText(GalleryGrabber.this.DICT.getValue("lblChangeLanguage") + " ");
				GalleryGrabber.this.lblImgPerSite.setText(GalleryGrabber.this.DICT.getValue("lblImgPerSite") + " ");
				GalleryGrabber.this.chkUseProxy.setText(GalleryGrabber.this.DICT.getValue("chkUseProxy"));
				GalleryGrabber.this.chkEmbedFlash.setText(GalleryGrabber.this.DICT.getValue("chkEmbedFlash"));
				GalleryGrabber.this.chkDelOld.setText(GalleryGrabber.this.DICT.getValue("chkDelOld"));
				GalleryGrabber.this.rbtLastDownload.setText(GalleryGrabber.this.DICT.getValue("rbtLastDownload"));				
				GalleryGrabber.this.rbtDate.setText(GalleryGrabber.this.DICT.getValue("rbtDate"));				
				GalleryGrabber.this.rbtAccount.setText(GalleryGrabber.this.DICT.getValue("rbtAccount"));
				GalleryGrabber.this.rbtPage.setText(GalleryGrabber.this.DICT.getValue("rbtPage"));
				GalleryGrabber.this.rbtAll.setText(GalleryGrabber.this.DICT.getValue("rbtAll"));
				GalleryGrabber.this.dcbDate.setDateFormat(GalleryGrabber.this.DICT.getValue("DateFormat"));
				GalleryGrabber.this.dcbDate.setDate(GalleryGrabber.this.dcbDate.getDate());
				GalleryGrabber.this.dcbDate.setMinimumSize(new JLabel(GalleryGrabber.this.DICT.getValue("DateFormat") + "xxxx").getMinimumSize());
				GalleryGrabber.this.dcbDate.setPreferredSize(new JLabel(GalleryGrabber.this.DICT.getValue("DateFormat") + "xxxx").getPreferredSize());
				GalleryGrabber.this.dcbDate.setMaximumSize(new JLabel(GalleryGrabber.this.DICT.getValue("DateFormat") + "xxxx").getMaximumSize());
				save();
			}
		});
		
		this.jtfImagesPerPage = new JTextField("100");
		// why can't this damn layout manager just stick to the preferred size? damn
		this.jtfImagesPerPage.setMinimumSize(new Dimension(50, this.jtfImagesPerPage.getPreferredSize().height));
		this.jtfImagesPerPage.setPreferredSize(new Dimension(50, this.jtfImagesPerPage.getPreferredSize().height));
		this.jtfImagesPerPage.setMaximumSize(new Dimension(50, this.jtfImagesPerPage.getPreferredSize().height));
		this.jtfImagesPerPage.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {
			}
			public void keyReleased(KeyEvent arg0) {
				char c = arg0.getKeyChar();
				if (Character.getType(c) != Character.CONTROL && Character.getType(c) != Character.UNASSIGNED && !Character.isDigit(c)) {
					GalleryGrabber.this.jtfImagesPerPage.setText(GalleryGrabber.this.jtfImagesPerPage.getText().substring(0, GalleryGrabber.this.jtfImagesPerPage.getText().length() - 1));
				}
			}
			public void keyTyped(KeyEvent arg0) {
			}
		});
		this.jtfImagesPerPage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// check if it's a number
				String s = GalleryGrabber.this.jtfImagesPerPage.getText();
				try {
					Integer.parseInt(s);
				} catch (Exception e) {
					// not numberal
					String s2 = "";
					for (int i = 0; i < s.length(); ++i) {
						if (Character.isDigit(s.charAt(i))) {
							s2 += s.charAt(i);
						}
					}
					GalleryGrabber.this.jtfImagesPerPage.setText(s2);
				}
			}
		});
		
		// Panels
		this.pnlAll = new JPanel();
		this.pnlAll.setLayout(new BoxLayout(this.pnlAll, BoxLayout.X_AXIS));
		this.pnlSites = new JPanel();
		this.pnlSites.setLayout(new BoxLayout(this.pnlSites, BoxLayout.Y_AXIS));
		this.pnlAccounts = new JPanel();
		this.pnlAccounts.setLayout(new BoxLayout(this.pnlAccounts, BoxLayout.Y_AXIS));
		this.pnlOptions = new JPanel();
		this.pnlOptions.setLayout(new BoxLayout(this.pnlOptions, BoxLayout.Y_AXIS));
		this.pnlChangeLang = new JPanel();
		this.pnlChangeLang.setLayout(new BoxLayout(this.pnlChangeLang, BoxLayout.X_AXIS));
		this.pnlChangeImgPerPage = new JPanel();
		this.pnlChangeImgPerPage.setLayout(new BoxLayout(this.pnlChangeImgPerPage, BoxLayout.X_AXIS));
		this.pnlProxy = new JPanel();
		this.pnlProxy.setLayout(new BoxLayout(this.pnlProxy, BoxLayout.X_AXIS));
		this.pnlRun = new JPanel();
		this.pnlRun.setLayout(new BoxLayout(this.pnlRun, BoxLayout.Y_AXIS));
		
		this.pnlChangeLang.add(Box.createHorizontalGlue());
		this.pnlChangeLang.add(this.lblChangeLanguage);
		this.pnlChangeLang.add(Box.createHorizontalGlue());
		this.pnlChangeLang.add(this.cbxLanguage);
		this.pnlChangeLang.add(Box.createHorizontalGlue());
		//pnlChangeLang.setMaximumSize(new Dimension(230, 200));
		
		this.pnlChangeImgPerPage.add(Box.createHorizontalGlue());
		this.pnlChangeImgPerPage.add(this.lblImgPerSite);
		this.pnlChangeImgPerPage.add(Box.createHorizontalGlue());
		this.pnlChangeImgPerPage.add(this.jtfImagesPerPage);
		this.pnlChangeImgPerPage.add(Box.createHorizontalGlue());
		//pnlChangeLang.setMaximumSize(new Dimension(230, 200));
		
		this.pnlProxy.add(Box.createHorizontalGlue());
		this.pnlProxy.add(this.chkUseProxy);
		this.pnlProxy.add(Box.createHorizontalGlue());
		this.pnlProxy.add(this.btnProxy);
		this.pnlProxy.add(Box.createHorizontalGlue());
		
		JScrollPane jspSites = new JScrollPane(this.lstSites);
		this.pnlSites.add(this.lblSites);
		this.pnlSites.add(jspSites);
		this.pnlSites.add(this.btnNewAccount);
		this.pnlSites.add(this.btnModifyAccount);
		this.pnlSites.add(this.btnCopyAccount);
		this.pnlSites.add(this.btnDeleteAccount);
		
		//to fill the button-place
		JPanel pnlBlubb = new JPanel();
		Dimension dBlubb = pnlBlubb.getMaximumSize();
		dBlubb.height = this.btnNewAccount.getMaximumSize().height * 4;
		pnlBlubb.setMaximumSize(dBlubb);
		dBlubb = pnlBlubb.getPreferredSize();
		dBlubb.height = this.btnNewAccount.getPreferredSize().height * 4;
		pnlBlubb.setPreferredSize(dBlubb);
		
		JScrollPane jspAccounts = new JScrollPane(this.lstAccounts);
		this.pnlAccounts.add(this.lblAccounts);
		this.pnlAccounts.add(jspAccounts);
		this.pnlAccounts.add(pnlBlubb);
		
		this.pnlOptions.add(this.lblImagesSince);
		this.pnlOptions.add(this.rbtLastDownload);
		this.pnlOptions.add(this.rbtDate);
		
		// i don't really get why i have to set this alignment. the default alignment
		// of dcbDate is centered. the default of the radio buttons and labels is left.
		// but when i run it that way, dcbDate is centered and all labels and buttons
		// are right aligned. i don't get it..
		this.dcbDate.setAlignmentX(LEFT_ALIGNMENT);
		this.pnlOptions.add(this.dcbDate);
		this.pnlOptions.add(Box.createVerticalGlue());
		this.pnlOptions.add(this.lblCheck);
		this.pnlOptions.add(this.rbtAccount);
		this.pnlOptions.add(this.rbtPage);
		this.pnlOptions.add(this.rbtAll);
		this.pnlOptions.add(Box.createVerticalGlue());
		this.pnlChangeLang.setAlignmentX(LEFT_ALIGNMENT);
		this.pnlOptions.add(this.pnlChangeLang);
		this.pnlChangeImgPerPage.setAlignmentX(LEFT_ALIGNMENT);
		this.pnlOptions.add(this.pnlChangeImgPerPage);
		this.chkEmbedFlash.setAlignmentX(LEFT_ALIGNMENT);
		this.pnlOptions.add(this.chkEmbedFlash);
		this.chkDelOld.setAlignmentX(LEFT_ALIGNMENT);
		this.pnlOptions.add(this.chkDelOld);
		this.pnlProxy.setAlignmentX(LEFT_ALIGNMENT);
		this.pnlOptions.add(this.pnlProxy);
		
		this.pnlRun.add(Box.createVerticalGlue());
		this.pnlRun.add(this.btnGo);
		this.pnlRun.add(Box.createVerticalGlue());
		
		this.pnlAll.add(this.pnlSites);
		this.pnlAll.add(this.pnlAccounts);
		this.pnlAll.add(Box.createHorizontalStrut(20));
		this.pnlAll.add(this.pnlOptions);
		this.pnlAll.add(this.pnlRun);
		
		this.pnlAll.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10)); 
		
		add(this.pnlAll);
		
		
//		there is no selected item at intialisation time
		this.btnGo.setEnabled(false);
		this.dcbDate.setEnabled(false);
		this.btnModifyAccount.setEnabled(false);
		this.btnCopyAccount.setEnabled(false);
		this.btnDeleteAccount.setEnabled(false);
		this.rbtAccount.setEnabled(false);
		
		this.rbtAll.setEnabled(false);
		this.rbtPage.setEnabled(false);
	}
	
	void addAccount(Account acc) {
		TreeMap<String, Account> mTmp = null;
		if (this.mAccountMap.containsKey(acc.PageName)) {
			mTmp = this.mAccountMap.get(acc.PageName);
		} else {
			mTmp = new TreeMap<String, Account>();
		}
		mTmp.put(acc.TargetUser, acc);
		this.mAccountMap.put(acc.PageName, mTmp);
		
		// add list to lstSites (if necessary)
		Collator tmpCollator = Collator.getInstance();
		if (!this.mdlSites.contains(acc.PageName)) {
			if (this.mdlSites.getSize() == 0) {
				this.mdlSites.addElement(acc.PageName);
				this.lstSites.setSelectedIndex(0);
			} else if (tmpCollator.compare(acc.PageName, this.mdlSites.elementAt(this.mdlSites.getSize() - 1)) > 0) {
				this.mdlSites.add(this.mdlSites.getSize(), acc.PageName);
				// attention: getSize became one larger than the one above
				this.lstSites.setSelectedIndex(this.mdlSites.getSize() - 1);
			} else {
				for (int i = 0; i < this.mdlSites.getSize(); ++i) {
					// as long as acc.PageName is greater than mdlSites.elementAt(i), nothing is to do
					if (tmpCollator.compare(acc.PageName, this.mdlSites.elementAt(i)) > 0) continue;
					// but if it's not, we insert the String at the cirrent pos and break
					this.mdlSites.add(i, acc.PageName);
					this.lstSites.setSelectedIndex(i);
					break;
				}
			} // else
		} else {
			// just to renew the lstAccounts and unset the copy-account-button
			int index = this.lstSites.getSelectedIndex();
			this.lstSites.clearSelection();
			this.lstSites.setSelectedIndex(index);
		}
	}
	
	void save() {
		if (this.bLoadingInProgress) return;
		try {
			PrintWriter out = new PrintWriter(new FileWriter(SAVEFILENAME));
			out.println("Please do not change anything in this file");
			out.println();
			out.println("lang=" + this.DICT.getLanguage());
			out.println("imgperpage=" + this.jtfImagesPerPage.getText());
			
			// proxy: eingeschaltet@%@host@%@port@%@username@%@pass
			String sProxy = this.chkUseProxy.isSelected() + "@%@" + this.mProxyMap.get("http.proxyHost") + "@%@" + this.mProxyMap.get("http.proxyPort") + "@%@";
			sProxy += Crypter.crypt(this.mProxyMap.get("http.proxyUser")) + "@%@" + Crypter.crypt(this.mProxyMap.get("http.proxyPassword"));
			out.println("proxy=" + sProxy);
			out.println("embedflash=" + this.chkEmbedFlash.isSelected());
			out.println("deleteold=" + this.chkDelOld.isSelected());
			out.println();
			
			Iterator<String> iterSites = this.mAccountMap.keySet().iterator();
			while (iterSites.hasNext()) {
				TreeMap<String, Account> underMap = this.mAccountMap.get(iterSites.next());
				Iterator<String> iterAccounts = underMap.keySet().iterator();
				while (iterAccounts.hasNext()) {
					out.println("<ACCOUNT>");
					Account acc = underMap.get(iterAccounts.next());
					out.println("PageName=" + acc.PageName);
					out.println("TargetUser=" + acc.TargetUser);
					out.println("m_sUser=" + acc.getCryptedUser());
					out.println("m_sPassword=" + acc.getCryptedPassword());
					DateFormat df = new SimpleDateFormat("dd/MM/yyyy/HH/mm/ss");
					String sLastDownload = df.format(acc.getDate());
					// 4. Sebtember 1993, 10:04:15.250 PM becomes
					// 4/9/1993/22/4/15
					
					out.println("m_cLastDownload=" + sLastDownload);
					out.println("</ACCOUNT>");
					out.println();
				}
			}
			
			out.close();
		} catch (IOException e) {
	    	System.err.println("Couldn't open file " + SAVEFILENAME + " for writing:");
	    	Logwriter.getInstance().writeLine("Couldn't open file " + SAVEFILENAME + " for writing:");
	    	e.printStackTrace();
	    	e.printStackTrace(Logwriter.getInstance().getPrintStream());
	    }
	}
	
	void removeDir(File dir) {
		if (!dir.exists()) return;
		String files[] = dir.list();
		for (int i = 0; i < files.length; i++) {
			if (files[i].equals(".") || files[i].equals("..")) continue;
			File dead = new File(dir, files[i]);
			if (!dead.isDirectory()) {
				dead.delete();
			} else {
				removeDir(dead);
				// dead.delete();
			}
		}
		dir.delete();
	}
	
	private void load() {
		if (!new File(SAVEFILENAME).exists()) return;
		this.bLoadingInProgress = true;
		
		//make a backupcopy
		InputStream fis = null;
		OutputStream fos = null;
		try {
			fis = new FileInputStream(new File(SAVEFILENAME).getAbsolutePath());
			new File(SAVEBACKUP).getParentFile().mkdirs();
			fos = new FileOutputStream(new File(SAVEBACKUP));
			byte[] buffer = new byte[ 0xFFFF ];
			for ( int len; (len = fis.read(buffer)) != -1; ) fos.write( buffer, 0, len );
	    } catch( IOException e ) {
	    	e.printStackTrace();
	    	e.printStackTrace(Logwriter.getInstance().getPrintStream());
	    } finally {
		    if ( fis != null )
		      try { fis.close(); } catch ( IOException e ) { e.printStackTrace();e.printStackTrace(Logwriter.getInstance().getPrintStream()); }
		    if ( fos != null )
		      try { fos.close(); } catch ( IOException e ) { e.printStackTrace();e.printStackTrace(Logwriter.getInstance().getPrintStream()); }
	    }
	    
	    // load stuff in vector
	    Vector<String> vLoadedData = new Vector<String>();
		try {
	        BufferedReader in = new BufferedReader(new FileReader(SAVEFILENAME));
	        String sValue;
	        while ((sValue = in.readLine()) != null) {
	        	if (sValue.trim().equals("")) continue;
	        	if (sValue.trim().equals("Please do not change anything in this file")) continue;
	        	vLoadedData.add(sValue);
	        }
	        in.close();
	    } catch (IOException e) {
	    	// could not open file.. seems that this is the first start so no file for reading
	    }
	        
	    // split file in accounts (and get out generic info)
	    String lang = "";
	    boolean proxy = false;
	    boolean embedflash = true;
	    boolean deleteOld = true;
	    String proxypass = "";
	    String proxyuser = "";
	    String proxyport = "";
	    String proxyhost = "";
	    Vector<String> vsAccounts = new Vector<String>();
	    for (int i = 0; i < vLoadedData.size(); ++i) {
	    	String s = vLoadedData.get(i);
	    	if (s.indexOf("lang=") != -1) {
	    		lang = s.substring(s.indexOf("=") + 1).trim();
	    		continue;
	    	}
	    	if (s.indexOf("imgperpage=") != -1) {
	    		this.jtfImagesPerPage.setText(s.substring(s.indexOf("=") + 1).trim());
	    		continue;
	    	}
	    	if (s.indexOf("proxy=") != -1) {
	    		s = s.substring(s.indexOf("=") + 1).trim();
	    		proxypass = Crypter.decrypt(s.substring(s.lastIndexOf("@%@") + 3));
        		s = s.substring(0, s.lastIndexOf("@%@"));
        		proxyuser = Crypter.decrypt(s.substring(s.lastIndexOf("@%@") + 3));
        		s = s.substring(0, s.lastIndexOf("@%@"));
        		proxyport = s.substring(s.lastIndexOf("@%@") + 3);
        		s = s.substring(0, s.lastIndexOf("@%@"));
        		proxyhost = s.substring(s.lastIndexOf("@%@") + 3);
        		s = s.substring(0, s.lastIndexOf("@%@"));
        		
        		if (s.equals("true")) {
        			proxy = true;
        		}
	    		continue;
	    	}
	    	if (s.indexOf("embedflash=") != -1) {
	    		s = s.substring(s.indexOf("=") + 1).trim();
        		if (s.equals("false")) {
        			embedflash = false;
        		}
	    		continue;
	    	}
	    	
	    	if (s.indexOf("deleteold=") != -1) {
	    		s = s.substring(s.indexOf("=") + 1).trim();
        		if (s.equals("false")) {
        			deleteOld = false;
        		}
	    		continue;
	    	}
	    	
	    	if (s.indexOf("<ACCOUNT>") != -1) {
	    		String sAccData = "";
	    		++i;
	    		while (true) {
	    			if (vLoadedData.get(i).indexOf("</ACCOUNT>") != -1) break;
	    			sAccData += vLoadedData.get(i) + "\n";
	    			++i;
	    		}
	    		vsAccounts.add(sAccData);
	    	}
	    }
	    
	    System.out.println("loading " + vsAccounts.size() + " accounts");
	    
	    // load accounts
	    for (int i = 0; i < vsAccounts.size(); ++i) {
	    	Account acc = new Account();
	    	String sAccLine = vsAccounts.get(i);
	    	
	    	if (sAccLine.indexOf("PageName=") == -1 || sAccLine.indexOf("TargetUser=") == -1 || sAccLine.indexOf("m_sUser=") == -1 ||
	    			sAccLine.indexOf("m_sPassword=") == -1 || sAccLine.indexOf("m_cLastDownload=") == -1) {
	    		System.err.println("Account " + i + " has not all values");
	    		continue;
	    	}
	    	int iStart = sAccLine.indexOf("PageName=") + 9;
	    	int iEnd = sAccLine.indexOf("\n", iStart);
	    	acc.PageName = sAccLine.substring(iStart, iEnd);
	    	
	    	iStart = sAccLine.indexOf("TargetUser=") + 11;
	    	iEnd = sAccLine.indexOf("\n", iStart);
	    	acc.TargetUser = sAccLine.substring(iStart, iEnd);
	    	
	    	iStart = sAccLine.indexOf("m_sUser=") + 8;
	    	iEnd = sAccLine.indexOf("\n", iStart);
	    	acc.setCryptedUser(sAccLine.substring(iStart, iEnd));
	    	
	    	iStart = sAccLine.indexOf("m_sPassword=") + 12;
	    	iEnd = sAccLine.indexOf("\n", iStart);
	    	acc.setCryptedPassword(sAccLine.substring(iStart, iEnd));
	    	
	    	iStart = sAccLine.indexOf("m_cLastDownload=") + 16;
	    	iEnd = sAccLine.indexOf("\n", iStart);
			try {
				acc.setDate(new SimpleDateFormat("dd/MM/yyyy/HH/mm/ss").parse(sAccLine.substring(iStart, iEnd)));
			} catch (ParseException e) {
				// Well, what can we do.. we set it to the actual date/time
				acc.setDate(Calendar.getInstance().getTime());
				System.err.println("could not load date from " + acc.PageName + "/" + acc.TargetUser + ", setting it to actual date");
			}
			
    		addAccount(acc);
	    }
	    
	    // set the rest of the info (at the end because some of it, like cbxLanguage.setSelectedItem(sValue),
	    // calls save() which would discard the accounts
	    this.cbxLanguage.setSelectedItem(lang);
	    this.mProxyMap.put("http.proxyPassword", proxypass);
		this.mProxyMap.put("http.proxyUser", proxyuser);
		this.mProxyMap.put("http.proxyPort", proxyport);
		this.mProxyMap.put("http.proxyHost", proxyhost);
		
		if (proxy) this.chkUseProxy.doClick();
		if (!embedflash) this.chkEmbedFlash.setSelected(false);
		if (!deleteOld) this.chkDelOld.setSelected(false);
		
		// just to be sure, call save again
		save();
		
	    this.lstSites.clearSelection();
	    this.mdlAccounts.clear();
	    this.bLoadingInProgress = false;
	}
	
	public static String getRelativePath(String sAbsolutePath, String basefolder) {
		// change the string sAbsolutePath to a relative string for the html
		// it should be relative to PAGEDIR
		
		// firstly save the filename so only the dir is left
		int iStart = sAbsolutePath.lastIndexOf(File.separator) + 1;
		String sFileName = sAbsolutePath.substring(iStart);
		
		StringBuilder sSourceDir = new StringBuilder(sAbsolutePath.substring(0, iStart));
		StringBuilder sRelDir = new StringBuilder(new File(basefolder).getAbsolutePath() + File.separator);
		
		// now we search from the left for a common base of PAGEDIR and sSourceDir
		while (sRelDir.length() != 0 && sSourceDir.length() != 0) {
			int iRelEnd = sRelDir.indexOf(File.separator);
			int iSrcEnd = sSourceDir.indexOf(File.separator);
			
			if (sRelDir.substring(0, iRelEnd).equals(sSourceDir.substring(0, iSrcEnd))) {
				sRelDir.delete(0, iRelEnd + 1);
				sSourceDir.delete(0, iSrcEnd + 1);
			} else {
				break;
			}
		}
		
		// now we add a "../" for every folder left in the path of sRelDir to sResult
		StringBuilder sResult = new StringBuilder("");
		while (sRelDir.length() != 0) {
			int iRelEnd = sRelDir.indexOf(File.separator);
			if (iRelEnd == -1) break;
			sResult.append("../");
			sRelDir.delete(0, iRelEnd + 1);
		}
		
		// and finally, we add the folders left in the path of sSourceDir to sResult
		while (sSourceDir.length() != 0) {
			int iSrcEnd = sSourceDir.indexOf(File.separator);
			if (iSrcEnd == -1) break;
			sResult.append(sSourceDir.substring(0, iSrcEnd) + "/");
			sSourceDir.delete(0, iSrcEnd + 1);
		}
		
		// finally we add the file back to the string
		sResult.append(sFileName);
		return sResult.toString();
	}
	
	
	
	JFrame frm = this;
	class Task implements Runnable {
		ProgressMonitor monitor = null;
		int iPercentFinished = 0;
		int iPercentSteps = 0;
		GrabberImage Image404 = new GrabberImage(new File(PATH_OF_404_IMG).getAbsolutePath(), "User not Found", "This user (account) was not found", Calendar.getInstance().getTime(), null);
		
    	public void run(){
    		if (GalleryGrabber.this.mAccountMap.isEmpty()) return; // lstSites wird hier sozusagen mitüberprüft

			String curDate = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss").format(new Date());
			String realImageDir = IMAGEDIR + File.separator + curDate;
    		
    		// delete the files from the last run (if any)
    		// the resultpages are deleted automagically with this
    		if (GalleryGrabber.this.chkDelOld.isSelected()) removeDir(new File(IMAGEDIR));
    		
    		this.monitor = ProgressUtil.createModalProgressMonitor(GalleryGrabber.this.frm, 100, false, 500); 
            
    		this.monitor.start(GalleryGrabber.this.DICT.getValue("InfoDialogTextStart"));
    		try{
    			ErrorLogger.getInstance().reset();
    			TreeMap<String, TreeMap<String, TreeSet<GrabberImage>>> ImageMap = getImages(realImageDir); 
    			save(); // save the "last download"-date
    			if (ImageMap == null) {
    				GalleryGrabber.this.btnGo.setEnabled(true);
    				if(this.monitor.getCurrent()!=this.monitor.getTotal()) this.monitor.setCurrent(null, this.monitor.getTotal()); 
    				return;
    			} else if (ImageMap.size() != 0) {
    				buildHTML(ImageMap, realImageDir);
    				
    				if (ErrorLogger.getInstance().getErrors().size() != 0) {
    					ErrorLogger.getInstance().showErrors(GalleryGrabber.this);
    				}
    				
    				// open resultpage in the system's standard browser
    				File resultFile = new File(realImageDir + File.separator + HTMLFOLDER + File.separator + FRAMESET_PGE);
    				try {
    					if (Desktop.isDesktopSupported()) {
    						Desktop desktop = Desktop.getDesktop();
    						desktop.browse(resultFile.toURI());
    					} else {
    						throw new Exception();
    					}
    				} catch (Exception e) {
    					JOptionPane.showMessageDialog(GalleryGrabber.this.ownFrame, GalleryGrabber.this.DICT.getValue("BrowserOpenErrorText") + "\n" + resultFile.getAbsolutePath(), GalleryGrabber.this.DICT.getValue("BrowserOpenErrorTitle"), JOptionPane.ERROR_MESSAGE);
    				}
    				
    			} else {
    				JOptionPane.showMessageDialog(GalleryGrabber.this.ownFrame, GalleryGrabber.this.DICT.getValue("NoNewImagesText"),
    						GalleryGrabber.this.DICT.getValue("NoNewImagesTitle"), JOptionPane.INFORMATION_MESSAGE);
    			}
    		} catch (Exception e) {
    			e.printStackTrace();
    			e.printStackTrace(Logwriter.getInstance().getPrintStream());
            } finally{ 
                // to ensure that progress dlg is closed in case of any exception 
                if(this.monitor.getCurrent()!=this.monitor.getTotal()) 
                    this.monitor.setCurrent(null, this.monitor.getTotal()); 
            } 
    		GalleryGrabber.this.btnGo.setEnabled(true); 
        }
    	
    	public synchronized TreeMap<String, TreeMap<String, TreeSet<GrabberImage>>> getImages(String realImageDir) {
    		// 1. string= seitenname, 2. string= targetusername, set= GrabberImages
    		TreeMap<String, TreeMap<String, TreeSet<GrabberImage>>> ImageMap = new TreeMap<String, TreeMap<String, TreeSet<GrabberImage>>>();
    		
    		// internet test
			try {
				URLConnection urlcon = new URL("http://www.google.de/index.html").openConnection();
				new BufferedReader(new InputStreamReader(urlcon.getInputStream(), "UTF8"));
			} catch (Exception e1) {
				// no connection to TEH INTARWEB
				JOptionPane.showMessageDialog(GalleryGrabber.this.ownFrame, GalleryGrabber.this.DICT.getValue("NoConnectionText"),
						GalleryGrabber.this.DICT.getValue("NoConnectionTitle"), JOptionPane.ERROR_MESSAGE);
				return null;
			}
    		// make a new accountmap with only the desired stuff in it
			TreeMap<String, TreeMap<String, Account>> tmpAccountMap = new TreeMap<String, TreeMap<String, Account>>();
			if (GalleryGrabber.this.mAccountMap == null) return null; // should never happen
			if (GalleryGrabber.this.rbtAll.isSelected()) {
				tmpAccountMap = GalleryGrabber.this.mAccountMap;
			} else if (GalleryGrabber.this.rbtPage.isSelected()) {
				if (GalleryGrabber.this.lstSites.getSelectedValue() == null) return null; // should also never happen
				String site = (String)GalleryGrabber.this.lstSites.getSelectedValue();
				tmpAccountMap.put(site, GalleryGrabber.this.mAccountMap.get(site));
			} else {
				// rbtAccount
				TreeMap<String, Account> tmpAccMap = new TreeMap<String, Account>();
				
				if (GalleryGrabber.this.lstSites.getSelectedValue() == null) return null; // should also never happen
				String site = (String)GalleryGrabber.this.lstSites.getSelectedValue();
				
				if (GalleryGrabber.this.lstAccounts.getSelectedValue() == null) return null; // should also never happen
				String account = (String)GalleryGrabber.this.lstAccounts.getSelectedValue();
				
				tmpAccMap.put(account, GalleryGrabber.this.mAccountMap.get(site).get(account));
				tmpAccountMap.put(site, tmpAccMap);
			} // else
			
			// shouldn't be to costly to iterate through the result again to get the
			// amounts of accounts in it. the map will probably never exceed 100 entries or so
			// and that should cost almost nothing until 'bout 10'000 entries
			int iAmountOfAccs = 0;
			Iterator<String> allIter = tmpAccountMap.keySet().iterator();
			while(allIter.hasNext()) {
				iAmountOfAccs += tmpAccountMap.get(allIter.next()).size();
				/*Iterator<String> pageIter = tmpAccountMap.get(allIter.next()).keySet().iterator();
				while(pageIter.hasNext()) {
					pageIter.next();
					++iAmountOfAccs;
				}*/
			}
			
			// calc the steps for the progressbar and set the start value
			// (start value is the value AFTER this beginning part here, which is at 0)
			this.iPercentSteps = 100 / (iAmountOfAccs + 1);
			this.iPercentFinished = this.iPercentSteps;
			
			// some run-throughs with the pages
			for (int i = 0; i < GalleryGrabber.this.vSites.size(); ++i) {
				allIter = tmpAccountMap.keySet().iterator();
				while(allIter.hasNext()) {
					String sPage = allIter.next();
					// if the current site (vSites) is not the current site (tmpAccountMap), continue
					if (!GalleryGrabber.this.vSites.get(i).getSitename().equals(sPage)) continue;
					
					try {
						boolean bLogin = GalleryGrabber.this.vSites.get(i).doLogin(tmpAccountMap.get(sPage).get(tmpAccountMap.get(sPage).firstKey()));
						if (!bLogin) {
							JOptionPane.showMessageDialog(GalleryGrabber.this.ownFrame, GalleryGrabber.this.DICT.getValue("LoginFailedText") + " " + sPage,
									GalleryGrabber.this.DICT.getValue("LoginFailedTitle"), JOptionPane.ERROR_MESSAGE);
							// calc new value for monitor
							Iterator<String> pageIter = tmpAccountMap.get(sPage).keySet().iterator();
							while(pageIter.hasNext()) {
								pageIter.next();
								this.iPercentFinished += this.iPercentSteps;
							}
							if (GalleryGrabber.this.rbtAll.isSelected()) continue;
							return null;
						}
					} catch (WrongUsernameOrPasswordException e) {
						JOptionPane.showMessageDialog(GalleryGrabber.this.ownFrame, GalleryGrabber.this.DICT.getValue("WrongUsernameOrPasswordText") + " " + sPage,
								GalleryGrabber.this.DICT.getValue("WrongUsernameOrPasswordTitle"), JOptionPane.ERROR_MESSAGE);
						// calc new value for monitor
						Iterator<String> pageIter = tmpAccountMap.get(sPage).keySet().iterator();
						while(pageIter.hasNext()) {
							pageIter.next();
							this.iPercentFinished += this.iPercentSteps;
						}
						if (GalleryGrabber.this.rbtAll.isSelected()) continue;
						return null;
					}
					
					TreeMap<String, TreeSet<GrabberImage>> accImgMap = new TreeMap<String, TreeSet<GrabberImage>>();
					
					Iterator<String> pageIter = tmpAccountMap.get(sPage).keySet().iterator();
					while(pageIter.hasNext()) {
						Date dateBeforeDownload = Calendar.getInstance().getTime();
						String sAcc = pageIter.next();
						Account acc = tmpAccountMap.get(sPage).get(sAcc);
						if (GalleryGrabber.this.rbtDate.isSelected()) {
		    				Calendar cal = Calendar.getInstance();
		            		cal.clear();
		            		cal.setTime(GalleryGrabber.this.dcbDate.getDate());
		            		acc.setDate(GalleryGrabber.this.dcbDate.getDate());
		    			}
						this.monitor.setCurrent(GalleryGrabber.this.DICT.getValue("InfoDialogTextDwnld") + " " + sPage + " - " + sAcc, this.iPercentFinished);
						this.iPercentFinished += this.iPercentSteps;
						
						File dir = new File(realImageDir + File.separator + sPage + File.separator + sAcc);
						dir.mkdirs();
						TreeSet<GrabberImage> imgs = GalleryGrabber.this.vSites.get(i).getImages(acc, dir.getAbsolutePath() + File.separator, this.Image404);
						if (imgs == null) {
							ErrorLogger.getInstance().addError(GalleryGrabber.this.vSites.get(i).getSitename(), "---", null, GalleryGrabber.this.DICT.getValue("ErrorDownloadingText") + " " + sAcc);
							//JOptionPane.showMessageDialog(ownFrame, DICT.getValue("ErrorDownloadingText") + " " + sPage + " - " + sAcc,
		    				//		DICT.getValue("ErrorDownloadingTitle"), JOptionPane.INFORMATION_MESSAGE);
							if (GalleryGrabber.this.rbtAccount.isSelected()) {
								//removeDir(new File(IMAGEDIR));
								return null;
							}
							
							//removeDir(new File(IMAGEDIR + File.separator + sPage + File.separator + sAcc));
							continue;
						}
						if (!imgs.isEmpty()) {
							accImgMap.put(sAcc, imgs);
						} else {
							//removeDir(new File(IMAGEDIR + File.separator + sPage + File.separator + sAcc));
						}
						acc.setDate(dateBeforeDownload);
					} // while
					if (!accImgMap.isEmpty()) {
						ImageMap.put(sPage, accImgMap);
					} else {
						//removeDir(new File(IMAGEDIR + File.separator + sPage));
					}
				} // while
			} // for
    		return ImageMap;
    	}// getImages()
    	
    	
    	
    	
    	public void buildHTML(TreeMap<String, TreeMap<String, TreeSet<GrabberImage>>> ImageMap, String realImageDir) {
    		// ich mache f�r jede unterseite einen eigenen loop. theoretisch k�nnte ich aber
    		// auch mehrere seiten "in einem rutsch" machen. so ist es jedoch �b ersichtlicher
    		// und von der geschwindigkeit her macht's f�r den user keinen unterschied
    		
    		String pageDir = realImageDir + File.separator + HTMLFOLDER;
    		
    		//monitor.setCurrent(DICT.getValue("InfoDialogTextHTML"), iPercentFinished);
    		File folder = new File(pageDir);
    		folder.mkdirs();
    		
    		// count how many images there are (to make an appropriate number of pages later
    		TreeMap<String, Integer> mNumOfPics = new TreeMap<String, Integer>();
    		mNumOfPics.put(ALL_PGE, 0);
	        Iterator<String> iterAll = ImageMap.keySet().iterator();
	        while (iterAll.hasNext()) {
	        	String sPage = iterAll.next();
	    		mNumOfPics.put(sPage, 0);
	        	Iterator<String> iterPage = ImageMap.get(sPage).keySet().iterator();
	        	while (iterPage.hasNext()) {
	        		String sTargetUser = iterPage.next();
	        		int i = ImageMap.get(sPage).get(sTargetUser).size();
	        		mNumOfPics.put(sPage + sTargetUser, i);
	        		mNumOfPics.put(sPage, mNumOfPics.get(sPage) + i);
	        		mNumOfPics.put(ALL_PGE, mNumOfPics.get(ALL_PGE) + i);
	        	}
	        }
    		
    		// frameset
    		File frameset = new File(pageDir + "/" + FRAMESET_PGE);
    		try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter(frameset.getAbsolutePath()));
    	        for (int i = 0; i < GalleryGrabber.this.FRAMESET.length; ++i) {
    	        	out.write(GalleryGrabber.this.FRAMESET[i]);
    	        	out.newLine();
    	        }
    	        out.close();
    	    } catch (IOException e) {
    	    }
    	    
    	    // startpage
    	    File start = new File(pageDir + "/" + START_PGE);
    		try {
    	        BufferedWriter out = new BufferedWriter(new FileWriter(start.getAbsolutePath()));
    	        for (int i = 0; i < PAGEHEADER.length; ++i) {
    	        	out.write(PAGEHEADER[i]);
    	        	out.newLine();
    	        }
    	        String relLogoPath = getRelativePath(new File(LOGO).getAbsolutePath(), pageDir);
    	        for (int i = 0; i < START.length; ++i) {
    	        	String line = START[i].replace("%LOGOPATH%", relLogoPath);
    	        	out.write(line);
    	        	out.newLine();
    	        }
    	        for (int i = 0; i < PAGEFOOTER.length; ++i) {
    	        	out.write(PAGEFOOTER[i]);
    	        	out.newLine();
    	        }
    	        out.close();
    	    } catch (IOException e) {
    	    	e.printStackTrace();
    	    	e.printStackTrace(Logwriter.getInstance().getPrintStream());
    	    }
    	    
    	    // navigation
    	    File navigation = new File(pageDir + "/" + NAVI_PGE);
    		try {
    	        BufferedWriter naviPage = new BufferedWriter(new FileWriter(navigation.getAbsolutePath()));
    	        for (int i = 0; i < PAGEHEADER.length; ++i) {
    	        	naviPage.write(PAGEHEADER[i]);
    	        	naviPage.newLine();
    	        }
    	        
    	        naviPage.write("<h3>" + stringToHTMLString(GalleryGrabber.this.DICT.getValue("NavigationTitle")) + "</h3>");
    	        naviPage.newLine();
    	        
    	        if (mNumOfPics.get(ALL_PGE) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
    	        	naviPage.write("<a href=\"" + stringToHTMLString(ALL_PGE) + ".html\" target=\"" + TARGET_NAME + "\">" + stringToHTMLString(GalleryGrabber.this.DICT.getValue("AllPageTitle")) + "</a><br>");
	    		} else {
	    			naviPage.write(stringToHTMLString(GalleryGrabber.this.DICT.getValue("AllPageTitle")) + "(");
	    			int iNumOfPages = (mNumOfPics.get(ALL_PGE) / (Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText()) + 1)) + 1; // wenn IMAGESPERPAGE = 500: 500 = 1, 501 = 2, 502 = 2 [...]
	    			for (int i = 1; i < iNumOfPages; ++i) {
	    				naviPage.write("<a href=\"" + stringToHTMLString(ALL_PGE + i) + ".html\" target=\"" + TARGET_NAME + "\">" + i + "</a>, ");
	    			}
	    			naviPage.write("<a href=\"" + stringToHTMLString(ALL_PGE + iNumOfPages) + ".html\" target=\"" + TARGET_NAME + "\">" + iNumOfPages + "</a>)<br>");
	    		}
    	        
    	        naviPage.newLine();
    	        
    	        iterAll = ImageMap.keySet().iterator();
        	    while (iterAll.hasNext()) {
        	    	String PageName = iterAll.next();
        	    	TreeMap<String, TreeSet<GrabberImage>> PageMap = ImageMap.get(PageName);
    	        	
    	        	if (mNumOfPics.get(PageName) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
    	        		naviPage.write("&nbsp;&nbsp;- <a href=\"" + stringToHTMLString(PageName) + ".html\" target=\"" + TARGET_NAME + "\">" + stringToHTMLString(PageName) + "</a><br>");
    	    		} else {
    	    			naviPage.write("&nbsp;&nbsp;- " + stringToHTMLString(PageName) + "(");
    	    			int iNumOfPages = (mNumOfPics.get(PageName) / (Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText()) + 1)) + 1; // wenn IMAGESPERPAGE = 500: 500 = 1, 501 = 2, 502 = 2 [...]
    	    			for (int i = 1; i < iNumOfPages; ++i) {
    	    				naviPage.write("<a href=\"" + stringToHTMLString(PageName + i) + ".html\" target=\"" + TARGET_NAME + "\">" + i + "</a>, ");
    	    			}
    	    			naviPage.write("<a href=\"" + stringToHTMLString(PageName + iNumOfPages) + ".html\" target=\"" + TARGET_NAME + "\">" + iNumOfPages + "</a>)<br>");
    	    		}
    	        	
        	    	naviPage.newLine();
        	    	
        	    	Iterator<String> iterPage = PageMap.keySet().iterator();
        	    	while (iterPage.hasNext()) {
        	    		String TargetUserName = iterPage.next();
        	    		if (PageMap.get(TargetUserName).size() <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
        	    			naviPage.write("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&gt; <a href=\"" + stringToHTMLString(PageName + TargetUserName) + ".html\" target=\"" + TARGET_NAME + "\">" + stringToHTMLString(TargetUserName) + "</a><br>");
        	    		} else {
        	    			naviPage.write("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&gt; " + stringToHTMLString(TargetUserName) + "(");
        	    			int iNumOfPages = (PageMap.get(TargetUserName).size() / (Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText()) + 1)) + 1; // wenn IMAGESPERPAGE = 500: 500 = 1, 501 = 2, 502 = 2 [...]
        	    			for (int i = 1; i < iNumOfPages; ++i) {
        	    				naviPage.write("<a href=\"" + stringToHTMLString(PageName + TargetUserName + i) + ".html\" target=\"" + TARGET_NAME + "\">" + i + "</a>, ");
        	    			}
        	    			naviPage.write("<a href=\"" + stringToHTMLString(PageName + TargetUserName + iNumOfPages) + ".html\" target=\"" + TARGET_NAME + "\">" + iNumOfPages + "</a>)<br>");
        	    		}
        	    		naviPage.newLine();
        	    	}
        	    	naviPage.newLine();
        	    }
    	        for (int i = 0; i < PAGEFOOTER.length; ++i) {
    	        	naviPage.write(PAGEFOOTER[i]);
    	        	naviPage.newLine();
    	        }
    	        naviPage.close();
    	    } catch (IOException e) {
    	    	e.printStackTrace();
    	    	e.printStackTrace(Logwriter.getInstance().getPrintStream());
    	    }
    	    
    	    
    	    
    	    // Page "All"
    	    File all;
    	    if (mNumOfPics.get(ALL_PGE) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
    	    	all = new File(pageDir + "/" + ALL_PGE + ".html");
    	    } else {
    	    	all = new File(pageDir + "/" + ALL_PGE + "1.html");
    	    }
    		try {
    			int iPicturesWritten = 0;
    			
    	        BufferedWriter allPage = new BufferedWriter(new FileWriter(all.getAbsolutePath()));
    	        for (int i = 0; i < PAGEHEADER.length; ++i) {
    	        	allPage.write(PAGEHEADER[i]);
    	        	allPage.newLine();
    	        }

    	        if (mNumOfPics.get(ALL_PGE) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
    	        	allPage.write("<h1>" + stringToHTMLString(GalleryGrabber.this.DICT.getValue("AllPageTitle")) + "</h1>");
        	    } else {
        	    	allPage.write("<h1>" + stringToHTMLString(GalleryGrabber.this.DICT.getValue("AllPageTitle")) + " 1</h1>");
        	    }
    	        allPage.newLine();
    	        
    	        iterAll = ImageMap.keySet().iterator();
        	    while (iterAll.hasNext()) {
        	    	String PageName = iterAll.next();
        	    	allPage.write("<h2>" + stringToHTMLString(PageName) + "</h2>");
        	    	allPage.newLine();
        	    	TreeMap<String, TreeSet<GrabberImage>> PageMap = ImageMap.get(PageName);
        	    	Iterator<String> iterPage = PageMap.keySet().iterator();
        	    	while (iterPage.hasNext()) {
        	    		String TargetUserName = iterPage.next();
        	    		allPage.write("<h3>" + stringToHTMLString(TargetUserName) + "</h3>");
            	    	allPage.newLine();
        	    		TreeSet<GrabberImage> ImageSet = PageMap.get(TargetUserName);
        	    		Iterator<GrabberImage> iterImage = ImageSet.iterator();
        	    		while (iterImage.hasNext()) {
        	    			GrabberImage img = iterImage.next();
        	    			if (img.OriginalUrl == null) {
        	    				allPage.write("<b>" + img.Title + "</b><br>");
        	    			} else {
        	    				allPage.write("<b><a href=\"" + img.OriginalUrl + "\" target=\"_blank\">" + img.Title + "</a></b><br>");
        	    			}
        	    			allPage.newLine();
        	    			allPage.write(new SimpleDateFormat(GalleryGrabber.this.DICT.getValue("DateFormat")).format(img.DateAndTime) + "<br>");
        	    			allPage.newLine();
        	    			if (img.Description != null) allPage.write(img.Description + "<br>");
        	    			allPage.newLine();
        	    			if (img.AdressOfLocalCopy.endsWith(".swf")) {
        	    				allPage.write("<a href=\"" + stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir)) + "\" target=\"_blank\">Link to Flash file</a><br>");
        	    				if (GalleryGrabber.this.chkEmbedFlash.isSelected()) {
        	    					allPage.write(FLASH_INCLUDE.replace("XXXXXXXX", stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir))));
        	    				}
        	    				allPage.write("<hr><br>");
        	    			} else {
        	    				allPage.write("<img src=\"" + stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir)) + "\" alt=\"" + stringToHTMLString(img.Title) + "\"><hr><br>");
        	    			}
        	    			allPage.newLine();allPage.newLine();allPage.newLine();
        	    			++iPicturesWritten;
        	    			
        	    			// build a new page if IMAGESPERPAGE pages are reached and there are images left
        	    			if (iPicturesWritten % Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText()) == 0 && iPicturesWritten < mNumOfPics.get(ALL_PGE)) {
        	    				for (int i = 0; i < PAGEFOOTER.length; ++i) {
        	        	        	allPage.write(PAGEFOOTER[i]);
        	        	        	allPage.newLine();
        	        	        }
        	        	        allPage.close();
        	        	        all = new File(pageDir + "/" + ALL_PGE + ((iPicturesWritten / Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) + 1) + ".html");
        	        	        allPage = new BufferedWriter(new FileWriter(all.getAbsolutePath()));
        	        	        for (int i = 0; i < PAGEHEADER.length; ++i) {
        	        	        	allPage.write(PAGEHEADER[i]);
        	        	        	allPage.newLine();
        	        	        }
        	        	        allPage.write("<h1>" + stringToHTMLString(GalleryGrabber.this.DICT.getValue("AllPageTitle")) + " " + ((iPicturesWritten / Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) + 1) + "</h1>");
        	        	        allPage.newLine();
    	        	        	if (iterPage.hasNext() || iterImage.hasNext()) {
    	        	        		allPage.write("<h2>" + stringToHTMLString(PageName) + "</h2>");
        	            	    	allPage.newLine();
    	        	        	}
    	        	        	if (iterImage.hasNext()) {
    	            	    		allPage.write("<h3>" + stringToHTMLString(TargetUserName) + "</h3>");
        	            	    	allPage.newLine();
    	            	    	}
        	    			}
        	    		}
        	    		allPage.write("<br><br><br>");
        	    		allPage.newLine();allPage.newLine();allPage.newLine();
        	    	}
        	    	allPage.write("<br><br><br>");
        	    	allPage.newLine();allPage.newLine();allPage.newLine();
        	    }
    	        
    	        for (int i = 0; i < PAGEFOOTER.length; ++i) {
    	        	allPage.write(PAGEFOOTER[i]);
    	        	allPage.newLine();
    	        }
    	        allPage.close();
    	    } catch (IOException e) {
    	    	e.printStackTrace();
    	    	e.printStackTrace(Logwriter.getInstance().getPrintStream());
    	    }
    	    
    	    
    	    // einzelne unterseiten f�r die Seiten
    	    iterAll = ImageMap.keySet().iterator();
    	    while (iterAll.hasNext()) {
    	    	String PageName = iterAll.next();
    	    	
	    	    File actual;
	    	    if (mNumOfPics.get(PageName) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
	    	    	actual = new File(pageDir + "/" + PageName + ".html");
	    	    } else {
	    	    	actual = new File(pageDir + "/" + PageName + "1.html");
	    	    }
	    		try {
	    			int iPicturesWritten = 0;
	    	        BufferedWriter actualPage = new BufferedWriter(new FileWriter(actual.getAbsolutePath()));
	    	        for (int i = 0; i < PAGEHEADER.length; ++i) {
	    	        	actualPage.write(PAGEHEADER[i]);
	    	        	actualPage.newLine();
	    	        }
	
	    	        if (mNumOfPics.get(PageName) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
	    	        	actualPage.write("<h1>" + stringToHTMLString(PageName) + "</h1>");
		    	    } else {
		    	    	actualPage.write("<h1>" + stringToHTMLString(PageName) + " 1</h1>");
		    	    }
	    	        actualPage.newLine();

        	    	TreeMap<String, TreeSet<GrabberImage>> PageMap = ImageMap.get(PageName);
        	    	Iterator<String> iterPage = PageMap.keySet().iterator();
        	    	while (iterPage.hasNext()) {
        	    		String TargetUserName = iterPage.next();
        	    		actualPage.write("<h2>" + stringToHTMLString(TargetUserName) + "</h2>");
        	    		actualPage.newLine();
        	    		TreeSet<GrabberImage> ImageSet = PageMap.get(TargetUserName);
        	    		Iterator<GrabberImage> iterImage = ImageSet.iterator();
        	    		while (iterImage.hasNext()) {
        	    			GrabberImage img = iterImage.next();
        	    			if (img.OriginalUrl == null) {
        	    				actualPage.write("<b>" + img.Title + "</b><br>");
        	    			} else {
        	    				actualPage.write("<b><a href=\"" + img.OriginalUrl + "\" target=\"_blank\">" + img.Title + "</a></b><br>");
        	    			}
        	    			actualPage.newLine();
        	    			actualPage.write(new SimpleDateFormat(GalleryGrabber.this.DICT.getValue("DateFormat")).format(img.DateAndTime) + "<br>");
        	    			actualPage.newLine();
        	    			if (img.Description != null) actualPage.write(img.Description + "<br>");
        	    			actualPage.newLine();
        	    			if (img.AdressOfLocalCopy.endsWith(".swf")) {
        	    				actualPage.write("<a href=\"" + stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir)) + "\" target=\"_blank\">Link to Flash file</a><br>");
        	    				if (GalleryGrabber.this.chkEmbedFlash.isSelected()) {
        	    					actualPage.write(FLASH_INCLUDE.replace("XXXXXXXX", stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir))));
        	    				}
        	    				actualPage.write("<hr><br>");
        	    			} else {
        	    				actualPage.write("<img src=\"" + stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir)) + "\" alt=\"" + stringToHTMLString(img.Title) + "\"><hr><br>");
        	    			}
        	    			actualPage.newLine();actualPage.newLine();actualPage.newLine();
        	    			++iPicturesWritten;
        	    			
        	    			// build a new page if IMAGESPERPAGE pages are reached and there are images left
        	    			if (iPicturesWritten % Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText()) == 0 && iPicturesWritten < mNumOfPics.get(PageName)) {
        	    				for (int i = 0; i < PAGEFOOTER.length; ++i) {
        	    					actualPage.write(PAGEFOOTER[i]);
        	    					actualPage.newLine();
        	        	        }
        	    				actualPage.close();
        	    				actual = new File(pageDir + "/" + PageName + ((iPicturesWritten / Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) + 1) + ".html");
        	    				actualPage = new BufferedWriter(new FileWriter(actual.getAbsolutePath()));
        	        	        for (int i = 0; i < PAGEHEADER.length; ++i) {
        	        	        	actualPage.write(PAGEHEADER[i]);
        	        	        	actualPage.newLine();
        	        	        }
        	        	        
    	        	        	actualPage.write("<h1>" + stringToHTMLString(PageName) + " " + ((iPicturesWritten / Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) + 1) + "</h1>");
    	        	        	actualPage.newLine();
    	        	        	if (iterImage.hasNext()) {
    	        	        		actualPage.write("<h2>" + stringToHTMLString(TargetUserName) + "</h2>");
    	        	        		actualPage.newLine();
    	            	    	}
        	    			}
        	    		}
        	    		actualPage.write("<hr><br>"); // doppelte hr nach seite
        	    		actualPage.newLine();actualPage.newLine();actualPage.newLine();
	        	    }
	    	        
	    	        for (int i = 0; i < PAGEFOOTER.length; ++i) {
	    	        	actualPage.write(PAGEFOOTER[i]);
	    	        	actualPage.newLine();
	    	        }
	    	        actualPage.close();
	    	    } catch (IOException e) {
	    	    	e.printStackTrace();
	    	    	e.printStackTrace(Logwriter.getInstance().getPrintStream());
	    	    }
    	    }
    	    
    	    // einzelne unterseiten f�r die TargetUsers
    	    iterAll = ImageMap.keySet().iterator();
    	    while (iterAll.hasNext()) {
    	    	String PageName = iterAll.next();
    	    	TreeMap<String, TreeSet<GrabberImage>> PageMap = ImageMap.get(PageName);
    	    	Iterator<String> iterPage = PageMap.keySet().iterator();
    	    	while (iterPage.hasNext()) {
    	    		String TargetUserName = iterPage.next();
    	    	
		    	    File actual;
		    	    if (mNumOfPics.get(PageName + TargetUserName) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
		    	    	actual = new File(pageDir + "/" + PageName + TargetUserName + ".html");
		    	    } else {
		    	    	actual = new File(pageDir + "/" + PageName + TargetUserName + "1.html");
		    	    }
		    	    try {
		    			int iPicturesWritten = 0;
		    	        BufferedWriter actualPage = new BufferedWriter(new FileWriter(actual.getAbsolutePath()));
		    	        for (int i = 0; i < PAGEHEADER.length; ++i) {
		    	        	actualPage.write(PAGEHEADER[i]);
		    	        	actualPage.newLine();
		    	        }
		
		    	        if (mNumOfPics.get(PageName + TargetUserName) <= Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) {
		    	        	actualPage.write("<h1>" + stringToHTMLString(TargetUserName) + "</h1>");
		        	    } else {
		        	    	actualPage.write("<h1>" + stringToHTMLString(TargetUserName) + " 1</h1>");
		        	    }
		    	        actualPage.newLine();
        	    		TreeSet<GrabberImage> ImageSet = PageMap.get(TargetUserName);
        	    		Iterator<GrabberImage> iterImage = ImageSet.iterator();
        	    		while (iterImage.hasNext()) {
        	    			GrabberImage img = iterImage.next();
        	    			if (img.OriginalUrl == null) {
        	    				actualPage.write("<b>" + img.Title + "</b><br>");
        	    			} else {
        	    				actualPage.write("<b><a href=\"" + img.OriginalUrl + "\" target=\"_blank\">" + img.Title + "</a></b><br>");
        	    			}
        	    			actualPage.newLine();
        	    			actualPage.write(new SimpleDateFormat(GalleryGrabber.this.DICT.getValue("DateFormat")).format(img.DateAndTime) + "<br>");
        	    			actualPage.newLine();
        	    			if (img.Description != null) actualPage.write(img.Description + "<br>");
        	    			actualPage.newLine();
        	    			if (img.AdressOfLocalCopy.endsWith(".swf")) {
        	    				actualPage.write("<a href=\"" + stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir)) + "\" target=\"_blank\">Link to Flash file</a><br>");
        	    				if (GalleryGrabber.this.chkEmbedFlash.isSelected()) {
        	    					actualPage.write(FLASH_INCLUDE.replace("XXXXXXXX", stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir))));
        	    				}
        	    				actualPage.write("<hr><br>");
        	    			} else {
        	    				actualPage.write("<img src=\"" + stringToHTMLString(getRelativePath(img.AdressOfLocalCopy, pageDir)) + "\" alt=\"" + stringToHTMLString(img.Title) + "\"><hr><br>");
        	    			}
        	    			actualPage.newLine();actualPage.newLine();actualPage.newLine();
        	    			++iPicturesWritten;
        	    			
        	    			// build a new page if IMAGESPERPAGE pages are reached and there are images left
        	    			if (iPicturesWritten % Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText()) == 0 && ImageSet.size() > iPicturesWritten) {
        	    				for (int i = 0; i < PAGEFOOTER.length; ++i) {
        	    					actualPage.write(PAGEFOOTER[i]);
        	    					actualPage.newLine();
        	        	        }
        	    				actualPage.close();
        	    				actual = new File(pageDir + "/" + PageName + TargetUserName + ((iPicturesWritten / Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) + 1) + ".html");
        	    				actualPage = new BufferedWriter(new FileWriter(actual.getAbsolutePath()));
        	        	        for (int i = 0; i < PAGEHEADER.length; ++i) {
        	        	        	actualPage.write(PAGEHEADER[i]);
        	        	        	actualPage.newLine();
        	        	        }
        	        	        
    	        	        	actualPage.write("<h1>" + stringToHTMLString(TargetUserName) + " " + ((iPicturesWritten / Integer.parseInt(GalleryGrabber.this.jtfImagesPerPage.getText())) + 1) + "</h1>");
    	        	        	actualPage.newLine();
        	    			}
        	    		}
        	    		actualPage.write("<br><br><br>");
        	    		actualPage.newLine();actualPage.newLine();actualPage.newLine();
		    	        
		    	        for (int i = 0; i < PAGEFOOTER.length; ++i) {
		    	        	actualPage.write(PAGEFOOTER[i]);
		    	        	actualPage.newLine();
		    	        }
		    	        actualPage.close();
		    	    } catch (IOException e) {
		    	    	e.printStackTrace();
		    	    	e.printStackTrace(Logwriter.getInstance().getPrintStream());
		    	    }
    	    	}
    	    }

			this.monitor.setCurrent(null, this.monitor.getTotal());
    	}
    	
    	
    	
    	// von S. Bayer, http://www.rgagnon.com/javadetails/java-0306.html
    	public String stringToHTMLString(String string) {
    	    StringBuffer sb = new StringBuffer(string.length());
    	    // true if last char was blank
    	    boolean lastWasBlankChar = false;
    	    int len = string.length();
    	    char c;

    	    for (int i = 0; i < len; i++)
    	        {
    	        c = string.charAt(i);
    	        if (c == ' ') {
    	            // blank gets extra work,
    	            // this solves the problem you get if you replace all
    	            // blanks with &nbsp;, if you do that you loss 
    	            // word breaking
    	            if (lastWasBlankChar) {
    	                lastWasBlankChar = false;
    	                sb.append("&nbsp;");
    	                }
    	            else {
    	                lastWasBlankChar = true;
    	                sb.append(' ');
    	                }
    	            }
    	        else {
    	            lastWasBlankChar = false;
    	            //
    	            // HTML Special Chars
    	            if (c == '"')
    	                sb.append("&quot;");
    	            else if (c == '&')
    	                sb.append("&amp;");
    	            else if (c == '<')
    	                sb.append("&lt;");
    	            else if (c == '>')
    	                sb.append("&gt;");
    	            else if (c == '\n')
    	                // Handle Newline
    	                sb.append("&lt;br/&gt;");
    	            else {
    	                int ci = 0xffff & c;
    	                if (ci < 160 )
    	                    // nothing special only 7 Bit
    	                    sb.append(c);
    	                else {
    	                    // Not 7 Bit use the unicode system
    	                    sb.append("&#");
    	                    sb.append(new Integer(ci).toString());
    	                    sb.append(';');
    	                    }
    	                }
    	            }
    	        }
    	    return sb.toString();
    	}
    }// Task
}