package Helpers;

import java.util.Calendar;
import java.util.Date;

public class Account implements Comparable<Account> {	
	private String m_sUser;
	private String m_sPassword;
	public String PageName;
	public String TargetUser;
	private Date m_cLastDownload;
	
	public Account() {
		this.m_cLastDownload = Calendar.getInstance().getTime();
	}
	
	public Account (String User, String Password, String PageName, String TargetUser, Date LastDownload) {
		setUser(User);
		setPassword(Password);
		this.PageName = PageName;
		this.TargetUser = TargetUser;
		this.m_cLastDownload = LastDownload;
	}
	
	public void setUser(String User) {
		this.m_sUser = Crypter.crypt(User);
	}
	
	public void setPassword(String Pass) {
		this.m_sPassword = Crypter.crypt(Pass);
	}
	
	public void setCryptedUser(String User) {
		this.m_sUser = User;
	}
	
	public void setCryptedPassword(String Pass) {
		this.m_sPassword = Pass;
	}
	
	public String getUser() {
		return Crypter.decrypt(this.m_sUser);
	}
	
	public String getPassword() {
		return Crypter.decrypt(this.m_sPassword);
	}
	
	public String getCryptedUser() {
		return this.m_sUser;
	}
	
	public String getCryptedPassword() {
		return this.m_sPassword;
	}
	
	public boolean setDate(int day, int month, int year, int hour, int minute) {
		if (month > 12 || month < 1) return false;
		if (day > 31 || day < 1) return false;
		
		// when date after today
		Calendar today = Calendar.getInstance();
		if (year > today.get(Calendar.YEAR)) return false;
		if (year == today.get(Calendar.YEAR)) {
			if (month > today.get(Calendar.MONTH)) return false;
			if (month == today.get(Calendar.MONTH)) {
				if (day > today.get(Calendar.DAY_OF_MONTH)) return false;
			}
		}
		
		//(alle 4 Jahre, au�er alle 100, wenn nicht durch 400 teilbar). 
		boolean isSchaltjahr = ((year % 4 == 0 && year % 100 != 0)  || year % 400 == 0);
		
		switch(month) {
		case 1:
		case 3:
		case 5:
		case 7:
		case 8:
		case 10:
		case 12:
			if (day > 31) return false;
			break;
		case 4:
		case 6:
		case 9:
		case 11:
			if (day > 30) return false;
			break;
		case 2:
			if (isSchaltjahr) {
				if (day > 29) return false;
			} else {
				if (day > 28) return false;
			}
			break;
		default:
			return false;
		}
		Calendar tmp = Calendar.getInstance();
		tmp.set(Calendar.DAY_OF_MONTH, day);
		tmp.set(Calendar.MONTH, month);
		tmp.set(Calendar.YEAR, year);
		tmp.set(Calendar.HOUR_OF_DAY, hour);
		tmp.set(Calendar.MINUTE, minute);
		tmp.set(Calendar.SECOND, 0);
		this.m_cLastDownload = tmp.getTime();
		return true;
	}
	
	public boolean setDate(Date date) {
		// when date after today
		Calendar today = Calendar.getInstance();
		Calendar check = Calendar.getInstance();
		check.clear();
		check.setTime(date);
		if (check.get(Calendar.YEAR) > today.get(Calendar.YEAR)) return false;
		if (check.get(Calendar.YEAR) == today.get(Calendar.YEAR)) {
			if (check.get(Calendar.MONTH) > today.get(Calendar.MONTH)) return false;
			if (check.get(Calendar.MONTH) == today.get(Calendar.MONTH)) {
				if (check.get(Calendar.DAY_OF_MONTH) > today.get(Calendar.DAY_OF_MONTH)) return false;
			}
		}
		
		this.m_cLastDownload = date;
		return true;
	}
	
	public void setDateToCurrentDate() {
		this.m_cLastDownload = Calendar.getInstance().getTime();
	}
	
	public Date getDate() {
		return this.m_cLastDownload;
	}

	public int compareTo(Account acc) {
		return this.TargetUser.compareToIgnoreCase(acc.TargetUser);
	}
}
