package Helpers;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Iterator;
import java.util.TreeMap;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

@SuppressWarnings("serial")
public class Builder {
	Dictionary dict = Dictionary.getInstance();
	ArrayList<Account> accounts = new ArrayList<Account>();
	Vector<Grabbable> vSites;
	// all accounts. first string: pagename. second string: accountname
	TreeMap<String, TreeMap<String, Account>> mAccountMap;
	String sUserBefore;
	String sPassBefore;
	
	String m_sPagename;
	String m_sUsername;
	String m_sPassword;
	String m_sTargetUser;
	
	JFrame frame = null;
	JDialog dialog = null;
	
	JLabel lblChooseSite = null;
	JComboBox cbxChooseSite = null;
	JPanel pnlChooseSite = new JPanel();
	JPanel pnlFixedOptions = null;
	JPanel pnlAll = new JPanel();
	
	public ArrayList<Account> getAccounts() {
		return this.accounts;
	}
	
	public Builder(Vector<Grabbable> sites, TreeMap<String, TreeMap<String, Account>> map, JFrame f) {
		this.vSites = sites;
		this.frame = f;
		this.mAccountMap = map;
	}
	
	public void displayBuilder() {
		displayBuilder(false, false);
	}
	public void displayCopier(Account acc) {
		this.m_sPagename = acc.PageName;
		this.m_sUsername = acc.getUser();
		this.m_sPassword = acc.getPassword();
		this.m_sTargetUser = acc.TargetUser;
		displayBuilder(true, false);
	}
	public void displayChanger(Account acc) {
		this.m_sPagename = acc.PageName;
		this.m_sUsername = acc.getUser();
		this.m_sPassword = acc.getPassword();
		this.m_sTargetUser = acc.TargetUser;
		displayBuilder(true, true);
	}
	
	private void displayBuilder(final boolean bCopy, final boolean bChange) {
		this.dialog = new JDialog(this.frame, true); // modal
		this.dialog.setTitle(this.dict.getValue("Builder_lblTitle"));
		this.dialog.setLocation(this.frame.getLocation());
		this.pnlAll.setLayout(new BoxLayout(this.pnlAll, BoxLayout.Y_AXIS));
		
		this.lblChooseSite = new JLabel(this.dict.getValue("Builder_lblChooseSite") + " ");
		String sLongest = "";
		String[] sSitenames = new String[this.vSites.size()];
		for (int i = 0; i < this.vSites.size(); ++i) {
			sSitenames[i] = this.vSites.elementAt(i).getSitename();
			if (sSitenames[i].length() > sLongest.length()) {
				sLongest = sSitenames[i];
			}
		}
		
		
		Arrays.sort(sSitenames);
		
		this.cbxChooseSite = new JComboBox(sSitenames);
		this.cbxChooseSite.setMinimumSize(new JLabel(sLongest + "xxxx").getMinimumSize());
		this.cbxChooseSite.setPreferredSize(new JLabel(sLongest + "xxxx").getPreferredSize());
		this.cbxChooseSite.setMaximumSize(new JLabel(sLongest + "xxxx").getMaximumSize());
		if (bCopy) this.cbxChooseSite.setSelectedItem(this.m_sPagename);
		this.pnlChooseSite.add(this.lblChooseSite);
		this.pnlChooseSite.add(this.cbxChooseSite);
		this.pnlChooseSite.add(Box.createHorizontalGlue());
		this.pnlAll.add(this.pnlChooseSite);
		
		int iIndex = getIndexOf(this.vSites, (String)this.cbxChooseSite.getSelectedItem());
		if (this.vSites.elementAt(iIndex).fixedTargetUsers()) {
			this.pnlFixedOptions = new FixedTargetUserPanel(bCopy); // copy is always true if change is
		} else {
			this.pnlFixedOptions = new TargetUserPanel(bCopy, bChange);
		}
		this.pnlAll.add(this.pnlFixedOptions);
		
		this.cbxChooseSite.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//BEWARE: if ever something is added to pnlAll AFTER pnlFixedOptions,
				// we're doomed
				
				int iIndex = getIndexOf(Builder.this.vSites, (String)Builder.this.cbxChooseSite.getSelectedItem());
				Builder.this.pnlAll.remove(Builder.this.pnlFixedOptions);
				if (Builder.this.vSites.elementAt(iIndex).fixedTargetUsers()) {
					Builder.this.pnlFixedOptions = new FixedTargetUserPanel(bCopy); // copy is always true if change is
				} else {
					Builder.this.pnlFixedOptions = new TargetUserPanel(bCopy, bChange);
				}
				Builder.this.pnlAll.add(Builder.this.pnlFixedOptions);
				Builder.this.pnlAll.validate();
			}
		});
		
		this.pnlAll.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10)); 
		this.dialog.add(this.pnlAll);
		this.dialog.setAlwaysOnTop(true);
		this.dialog.setSize(550, 300);
		this.dialog.setResizable(false);
		this.dialog.setVisible(true);
	}	
	
	class FixedTargetUserPanel extends JPanel {
		JLabel lblDescr = null;
		JLabel lblTargetUsrDescr = null;
		JLabel lblUsername = null;
		JLabel lblPassword = null;
		
		JTextField tfdUsername = null;
		JPasswordField pfdPassword = null;
		
		JComboBox cbxAccountDescr = null;
		
		JButton btnSave = null;
		JButton btnAbort = null;
		
		JPanel pnlDescr = new JPanel();
		JPanel pnlInputs = new JPanel();
		JPanel pnlLabels = new JPanel();
		JPanel pnlFields = new JPanel();
		JPanel pnlSaveAbort = new JPanel();
		
		FixedTargetUserPanel(boolean bCopy) {
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
			
			final int iIndexOfSite = getIndexOf(Builder.this.vSites, (String)Builder.this.cbxChooseSite.getSelectedItem());
			
			String sDescr = Builder.this.vSites.elementAt(iIndexOfSite).getDescription();
			this.lblDescr = new JLabel("<html><div align=\"center\">" + Builder.this.dict.getValue("Builder_lblDescr") + " " + sDescr + "</div></html>");
			this.pnlDescr.setLayout(new BoxLayout(this.pnlDescr, BoxLayout.X_AXIS));
			this.pnlDescr.add(Box.createHorizontalGlue());
			this.pnlDescr.add(this.lblDescr);
			this.pnlDescr.add(Box.createHorizontalGlue());
			
			
			this.lblTargetUsrDescr = new JLabel(Builder.this.vSites.elementAt(iIndexOfSite).getTargetUserDescription());
			
			
			String[] sTargetUsers = Builder.this.vSites.elementAt(iIndexOfSite).getFixedTargetUsers();
			Arrays.sort(sTargetUsers);
			/* bubblesort
			boolean bUnsorted;
			do {
				bUnsorted = false;
				Collator tmpCollator = Collator.getInstance();
				for (int i = 0; i < sTargetUsers.length - 1; ++i) {
					if (tmpCollator.compare(sTargetUsers[i], sTargetUsers[i + 1]) > 0) {
						String sTmp = sTargetUsers[i];
						sTargetUsers[i] = sTargetUsers[i + 1];
						sTargetUsers[i + 1] = sTmp;
						bUnsorted = true;
					}
				}
			} while (bUnsorted);*/
			
			this.cbxAccountDescr = new JComboBox(sTargetUsers);
			String sLongest = "";
			for (int i = 0; i < Builder.this.vSites.elementAt(iIndexOfSite).getFixedTargetUsers().length; ++i) {
				if (Builder.this.vSites.elementAt(iIndexOfSite).getFixedTargetUsers()[i].length() > sLongest.length()) {
					sLongest = Builder.this.vSites.elementAt(iIndexOfSite).getFixedTargetUsers()[i];
				}
			}
			this.cbxAccountDescr.setMinimumSize(new JLabel(sLongest + "xxxx").getMinimumSize());
			this.cbxAccountDescr.setPreferredSize(new JLabel(sLongest + "xxxx").getPreferredSize());
			this.cbxAccountDescr.setMaximumSize(new JLabel(sLongest + "xxxx").getMaximumSize());
			this.pnlLabels.setLayout(new BoxLayout(this.pnlLabels, BoxLayout.Y_AXIS));
			this.pnlLabels.add(this.lblTargetUsrDescr);
			this.pnlFields.setLayout(new BoxLayout(this.pnlFields, BoxLayout.Y_AXIS));
			this.pnlFields.add(this.cbxAccountDescr);
			
			if (Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForSpecialContent() && !Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent()) {
				this.lblUsername = new JLabel(Builder.this.dict.getValue("Builder_lblUsername") + " (Optional) ");
			} else {
				this.lblUsername = new JLabel(Builder.this.dict.getValue("Builder_lblUsername") + " ");
			}
			this.tfdUsername = new JTextField();
			this.tfdUsername.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
			this.tfdUsername.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
			this.tfdUsername.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
			this.pnlLabels.add(this.lblUsername);
			this.pnlFields.add(this.tfdUsername);
			this.lblUsername.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent());
			this.tfdUsername.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent());
						
			
			if (Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForSpecialContent() && !Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent()) {
				this.lblPassword = new JLabel(Builder.this.dict.getValue("Builder_lblPassword") + " (Optional) ");
			} else {
				this.lblPassword = new JLabel(Builder.this.dict.getValue("Builder_lblPassword") + " ");
			}
			this.pfdPassword = new JPasswordField ();
			this.pfdPassword.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
			this.pfdPassword.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
			this.pfdPassword.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
			if (!this.pfdPassword.echoCharIsSet()) this.pfdPassword.setEchoChar('*');
			this.pnlLabels.add(this.lblPassword);
			this.pnlFields.add(this.pfdPassword);
			this.lblPassword.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent());
			this.pfdPassword.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent());
			
			this.pnlInputs.setLayout(new BoxLayout(this.pnlInputs, BoxLayout.X_AXIS));
			this.pnlInputs.add(this.pnlLabels);
			this.pnlInputs.add(this.pnlFields);			
			
			this.btnSave = new JButton(Builder.this.dict.getValue("Builder_btnSave"));
			this.btnSave.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Account acc = new Account();
					acc.PageName = Builder.this.vSites.elementAt(iIndexOfSite).getSitename();
					acc.TargetUser = (String)FixedTargetUserPanel.this.cbxAccountDescr.getSelectedItem();
					
					acc.setUser(FixedTargetUserPanel.this.tfdUsername.getText().trim());
					if (!acc.getUser().equals(Builder.this.sUserBefore) && Builder.this.mAccountMap.containsKey(acc.PageName) && !Builder.this.mAccountMap.get(acc.PageName).isEmpty()) {
						// Username hat ge�ndert, alle user der seite Updaten
						TreeMap<String, Account> accs = Builder.this.mAccountMap.get(acc.PageName);
						Iterator<String> iter = accs.keySet().iterator();
						while (iter.hasNext()) {
							accs.get(iter.next()).setUser(acc.getUser());
						}
					}
					
					String sPass = new String(FixedTargetUserPanel.this.pfdPassword.getPassword());
					acc.setPassword(sPass.trim());
					if (!acc.getPassword().equals(Builder.this.sPassBefore) && Builder.this.mAccountMap.containsKey(acc.PageName) && !Builder.this.mAccountMap.get(acc.PageName).isEmpty()) {
						// Passwort hat ge�ndert, alle user der seite Updaten
						TreeMap<String, Account> accs = Builder.this.mAccountMap.get(acc.PageName);
						Iterator<String> iter = accs.keySet().iterator();
						while (iter.hasNext()) {
							accs.get(iter.next()).setPassword(acc.getPassword());
						}
					}

					// if everything is set
					boolean bEverythingSet = true;
					if (acc.TargetUser.replaceAll(";", "").trim().equals("")) {
						FixedTargetUserPanel.this.lblTargetUsrDescr.setForeground(Color.RED);
						bEverythingSet = false;
					} else {
						FixedTargetUserPanel.this.lblTargetUsrDescr.setForeground(Color.BLACK);
					}
					if (Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent()) {
						if (acc.getPassword().equals("")) {
							FixedTargetUserPanel.this.lblPassword.setForeground(Color.RED);
							bEverythingSet = false;
						} else {
							FixedTargetUserPanel.this.lblPassword.setForeground(Color.BLACK);
						}
					}
					if (Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent()) {
						if (acc.getUser().equals("")) {
							FixedTargetUserPanel.this.lblUsername.setForeground(Color.RED);
							bEverythingSet = false;
						} else {
							FixedTargetUserPanel.this.lblUsername.setForeground(Color.BLACK);
						}
					}
					if (!bEverythingSet) return;
					
					acc.setDate(Calendar.getInstance().getTime());
					Builder.this.accounts.add(acc);
					Builder.this.dialog.dispose();
					Builder.this.dialog.setVisible(false);
				}
			});
			
			this.btnAbort = new JButton(Builder.this.dict.getValue("Builder_btnAbort"));
			this.btnAbort.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Builder.this.accounts.clear();
					Builder.this.dialog.dispose();
					Builder.this.dialog.setVisible(false);
				}
			});
			
			this.pnlSaveAbort.setLayout(new BoxLayout(this.pnlSaveAbort, BoxLayout.X_AXIS));
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			this.pnlSaveAbort.add(this.btnSave);
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			this.pnlSaveAbort.add(this.btnAbort);
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			
			if (bCopy) {
				this.cbxAccountDescr.setSelectedItem(Builder.this.m_sTargetUser);
			}
			
			// pro seite gibt es immer nur ein passwort/username
			if (Builder.this.mAccountMap.containsKey(Builder.this.vSites.elementAt(iIndexOfSite).getSitename())) {
				TreeMap<String, Account> map = Builder.this.mAccountMap.get(Builder.this.vSites.elementAt(iIndexOfSite).getSitename());
				Account anyAcc = map.get(map.firstKey());
				this.tfdUsername.setText(anyAcc.getUser());
				this.pfdPassword.setText(anyAcc.getPassword());
				Builder.this.sUserBefore = anyAcc.getUser();
				Builder.this.sPassBefore = anyAcc.getPassword();
			}
			
			add(this.pnlDescr);
			add(Box.createVerticalGlue());
			add(this.pnlInputs);
			add(Box.createVerticalGlue());
			add(this.pnlSaveAbort);
		}
	}
	
	class TargetUserPanel extends JPanel {
		JLabel lblDescr = null;
		JLabel lblTargetUsrDescr = null;
		JLabel lblUsername = null;
		JLabel lblPassword = null;
		
		JTextField tfdUsername = null;
		JPasswordField pfdPassword = null;
		
		JTextArea tfaAccountDescr = null;
		
		JButton btnSave = null;
		JButton btnAbort = null;
		
		JPanel pnlDescr = new JPanel();
		JPanel pnlInputs = new JPanel();
		JPanel pnlLabels = new JPanel();
		JPanel pnlFields = new JPanel();
		JPanel pnlSaveAbort = new JPanel();
		
		TargetUserPanel(boolean bCopy, final boolean bChange) {
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
			
			final int iIndexOfSite = getIndexOf(Builder.this.vSites, (String)Builder.this.cbxChooseSite.getSelectedItem());
			
			String sDescr = Builder.this.vSites.elementAt(iIndexOfSite).getDescription();
			this.lblDescr = new JLabel("<html><div align=\"center\">" + Builder.this.dict.getValue("Builder_lblDescr") + " " + sDescr + "</div></html>");
			this.pnlDescr.setLayout(new BoxLayout(this.pnlDescr, BoxLayout.X_AXIS));
			this.pnlDescr.add(Box.createHorizontalGlue());
			this.pnlDescr.add(this.lblDescr);
			this.pnlDescr.add(Box.createHorizontalGlue());
			
			
			this.lblTargetUsrDescr = new JLabel(Builder.this.vSites.elementAt(iIndexOfSite).getTargetUserDescription() + " ");
			this.tfaAccountDescr = new JTextArea();
			JScrollPane accountDescrArea = null;
			if (bChange) {
				Dimension labelDimension = new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize();
				this.tfaAccountDescr.setMinimumSize(labelDimension);
				this.tfaAccountDescr.setPreferredSize(labelDimension);
				this.tfaAccountDescr.setMaximumSize(labelDimension);
			} else {
				this.tfaAccountDescr.setLineWrap(true);
				this.tfaAccountDescr.setWrapStyleWord(true);
				accountDescrArea = new JScrollPane(this.tfaAccountDescr);
				Dimension labelDimension = new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize();
				accountDescrArea.setMinimumSize(labelDimension);
				accountDescrArea.setPreferredSize(new Dimension(labelDimension.width, labelDimension.height * 3));
				accountDescrArea.setMaximumSize(new Dimension(labelDimension.width, labelDimension.height * 3));
			}
			this.pnlLabels.setLayout(new BoxLayout(this.pnlLabels, BoxLayout.Y_AXIS));
			this.pnlLabels.add(this.lblTargetUsrDescr);
			if (!bChange) {
				this.pnlLabels.add(new JLabel(Builder.this.dict.getValue("Builder_lblUsername_semi")));
				this.pnlLabels.add(new JLabel(" ")); // spacer
			}
			this.pnlFields.setLayout(new BoxLayout(this.pnlFields, BoxLayout.Y_AXIS));
			if (bChange) {
				this.pnlFields.add(this.tfaAccountDescr);
			} else {
				this.pnlFields.add(accountDescrArea);
			}
			
			
			if (Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForSpecialContent() && !Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent()) {
				this.lblUsername = new JLabel(Builder.this.dict.getValue("Builder_lblUsername") + " (Optional) ");
			} else {
				this.lblUsername = new JLabel(Builder.this.dict.getValue("Builder_lblUsername") + " ");
			}
			this.tfdUsername = new JTextField();
			this.tfdUsername.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
			this.tfdUsername.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
			this.tfdUsername.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
			this.pnlLabels.add(this.lblUsername);
			this.pnlFields.add(this.tfdUsername);
			this.lblUsername.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent());
			this.tfdUsername.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent());
						
			
			if (Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForSpecialContent() && !Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent()) {
				this.lblPassword = new JLabel(Builder.this.dict.getValue("Builder_lblPassword") + " (Optional) ");
			} else {
				this.lblPassword = new JLabel(Builder.this.dict.getValue("Builder_lblPassword") + " ");
			}
			this.pfdPassword = new JPasswordField ();
			this.pfdPassword.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
			this.pfdPassword.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
			this.pfdPassword.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
			if (!this.pfdPassword.echoCharIsSet()) this.pfdPassword.setEchoChar('*');
			this.pnlLabels.add(this.lblPassword);
			this.pnlFields.add(this.pfdPassword);
			this.lblPassword.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent());
			this.pfdPassword.setEnabled(Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForSpecialContent() || Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent());
			
			this.pnlInputs.setLayout(new BoxLayout(this.pnlInputs, BoxLayout.X_AXIS));
			this.pnlInputs.add(this.pnlLabels);
			this.pnlInputs.add(this.pnlFields);			
			
			this.btnSave = new JButton(Builder.this.dict.getValue("Builder_btnSave"));
			this.btnSave.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String pageName = Builder.this.vSites.elementAt(iIndexOfSite).getSitename();
					String targetUser = TargetUserPanel.this.tfaAccountDescr.getText().trim();
					if (bChange && targetUser.contains(";")) targetUser = targetUser.substring(0, targetUser.indexOf(";"));
					String userName = TargetUserPanel.this.tfdUsername.getText().trim();
					String password = new String(TargetUserPanel.this.pfdPassword.getPassword());
					
					if (!userName.equals(Builder.this.sUserBefore) && Builder.this.mAccountMap.containsKey(pageName) && !Builder.this.mAccountMap.get(pageName).isEmpty()) {
						// Username hat ge�ndert, alle user der seite Updaten
						TreeMap<String, Account> accs = Builder.this.mAccountMap.get(pageName);
						Iterator<String> iter = accs.keySet().iterator();
						while (iter.hasNext()) {
							accs.get(iter.next()).setUser(userName);
						}
					}
					
					if (!password.equals(Builder.this.sPassBefore) && Builder.this.mAccountMap.containsKey(pageName) && !Builder.this.mAccountMap.get(pageName).isEmpty()) {
						// Passwort hat ge�ndert, alle user der seite Updaten
						TreeMap<String, Account> accs = Builder.this.mAccountMap.get(pageName);
						Iterator<String> iter = accs.keySet().iterator();
						while (iter.hasNext()) {
							accs.get(iter.next()).setPassword(password);
						}
					}
					
					// if everything is set
					boolean bEverythingSet = true;
					if ((bChange && targetUser.isEmpty()) || (!bChange && targetUser.replaceAll(";", "").isEmpty())) {
						TargetUserPanel.this.lblTargetUsrDescr.setForeground(Color.RED);
						bEverythingSet = false;
					} else {
						TargetUserPanel.this.lblTargetUsrDescr.setForeground(Color.BLACK);
					}
					if (Builder.this.vSites.elementAt(iIndexOfSite).needsPasswordForAllContent()) {
						if (password.isEmpty()) {
							TargetUserPanel.this.lblPassword.setForeground(Color.RED);
							bEverythingSet = false;
						} else {
							TargetUserPanel.this.lblPassword.setForeground(Color.BLACK);
						}
					}
					if (Builder.this.vSites.elementAt(iIndexOfSite).needsUsernameForAllContent()) {
						if (userName.equals("")) {
							TargetUserPanel.this.lblUsername.setForeground(Color.RED);
							bEverythingSet = false;
						} else {
							TargetUserPanel.this.lblUsername.setForeground(Color.BLACK);
						}
					}
					if (!bEverythingSet) return;
					
					for (String targetUserName : targetUser.split(";")) {
						targetUserName = targetUserName.trim();
						if (targetUserName.isEmpty()) continue;
						Account acc = new Account(userName, password, pageName, targetUserName, Calendar.getInstance().getTime());
						Builder.this.accounts.add(acc);
						if (bChange) break; // only one user if change
					}
					
					Builder.this.dialog.dispose();
					Builder.this.dialog.setVisible(false);
				}
			});
			
			this.btnAbort = new JButton(Builder.this.dict.getValue("Builder_btnAbort"));
			this.btnAbort.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Builder.this.accounts.clear();
					Builder.this.dialog.dispose();
					Builder.this.dialog.setVisible(false);
				}
			});
			
			this.pnlSaveAbort.setLayout(new BoxLayout(this.pnlSaveAbort, BoxLayout.X_AXIS));
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			this.pnlSaveAbort.add(this.btnSave);
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			this.pnlSaveAbort.add(this.btnAbort);
			this.pnlSaveAbort.add(Box.createHorizontalGlue());
			
			if (bCopy) {
				this.tfaAccountDescr.setText(Builder.this.m_sTargetUser);
			}
			
			// pro seite gibt es immer nur ein passwort/username
			if (Builder.this.mAccountMap.containsKey(Builder.this.vSites.elementAt(iIndexOfSite).getSitename())) {
				TreeMap<String, Account> map = Builder.this.mAccountMap.get(Builder.this.vSites.elementAt(iIndexOfSite).getSitename());
				Account anyAcc = map.get(map.firstKey());
				this.tfdUsername.setText(anyAcc.getUser());
				this.pfdPassword.setText(anyAcc.getPassword());
				Builder.this.sUserBefore = anyAcc.getUser();
				Builder.this.sPassBefore = anyAcc.getPassword();
			}
			
			add(this.pnlDescr);
			add(Box.createVerticalGlue());
			add(this.pnlInputs);
			add(Box.createVerticalGlue());
			add(this.pnlSaveAbort);
		}
	}
	
	int getIndexOf(Vector<Grabbable> vSites, String sName) {
		for (int i = 0; i < vSites.size(); ++i) {
			if (vSites.elementAt(i).getSitename().equals(sName)) {
				return i;
			}
		}
		return -1;
	}
}
