package Sites;

import java.net.MalformedURLException;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;
import java.util.TreeSet;

import klaue.DownloadHelper.Downloader;
import Helpers.Account;
import Helpers.ErrorLogger;
import Helpers.Grabbable;
import Helpers.GrabberImage;
import Helpers.Logwriter;

/*
 * currently defunct
 */
public class SoFurry implements Grabbable {
	final String PAGENAME = "SoFurry";
	final String ARTIST_URL_PRE = "http://www.yiffstar.com/index.yiff?action=authorsearch&authorsearch=";
	final String ARTIST_URL_PAST = "&tabselected=gallery&sort=date";
	final String IMAGE_URL = "http://www.yiffstar.com/index.yiff?pid=";
	final String TIMEZONE = "Europe/Berlin";
	
	GrabberImage m_fourOhFourImg = null;
	String m_ImageFolder = "";

	public TreeSet<GrabberImage> getImages(Account acc, String sSavePath, GrabberImage userNotFoundImg) {
		if (acc == null) return null;
		this.m_ImageFolder = sSavePath;
		this.m_fourOhFourImg = userNotFoundImg;
		
		// getting website
		URL url = null;
		try {
			url = new URL(this.ARTIST_URL_PRE + acc.TargetUser + this.ARTIST_URL_PAST);
		} catch (MalformedURLException e) {
			TreeSet<GrabberImage> mReturnSet = new TreeSet<GrabberImage>();
			mReturnSet.add(userNotFoundImg);
			return mReturnSet;
		}
		
		return getImagesFromAccount(url, acc.getDate(), acc.TargetUser);
	}

	public boolean doLogin(Account acc) {
		return true;
	}

	public boolean isFromThisSite(Account acc) {
		if (acc.PageName.equals(this.PAGENAME)) return true;
		return false;
	}

	public boolean needsUsernameForAllContent() {
		return false;
	}

	public boolean needsPasswordForAllContent() {
		return false;
	}

	public boolean needsUsernameForSpecialContent() {
		return false;
	}

	public boolean needsPasswordForSpecialContent() {
		return false;
	}

	public boolean fixedTargetUsers() {
		return false;
	}

	public String[] getFixedTargetUsers() {
		return null;
	}

	public String getTargetUserDescription() {
		return "Username to watch: ";
	}

	public String getSitename() {
		return this.PAGENAME;
	}

	public String getDescription() {
		return "Here you'll find a large selection of a growing number of furry drawings and pictures. The vast majority of these are of adult nature - the perfect way to unwind and... relax... after a stressful day ;) " + 
               "No matter what your favourite kink is, and no matter whether you are looking for heterosexual, bisexual or homosexual art - it's all right there, waiting to be discovered by you. This is an adult site containing sexual content. " +
               "Depending on your country, you must be at least 18 or even 21 years old to enter.";
	}
	
	private TreeSet<GrabberImage> getImagesFromAccount(URL mainUrl, Date date, String sTargetUser) {
		TreeSet<GrabberImage> set = new TreeSet<GrabberImage>();
		try {
			ArrayList<String> page = Downloader.downloadPage(mainUrl, null, null, 20000, 3);
			for (String sLine : page) {
				if (sLine.indexOf("No such user found in our database!") != -1) {
					set.add(this.m_fourOhFourImg);
					return set;
				}
				
				if (sLine.indexOf("<tr class=\"tabletwo\">") != -1 || sLine.indexOf("<tr class=\"tableone\">") != -1) {
					// get date
					int iStart = sLine.lastIndexOf("<font face=\"Arial\" size=-1>") - 1;
					iStart = sLine.lastIndexOf("size=-1>", iStart) + 8;
					int iEnd = sLine.indexOf("</font>", iStart);
					String sDate = sLine.substring(iStart, iEnd);
					
	        		DateFormat df = new SimpleDateFormat("dd-MMM-yyyy", Locale.US);
	        		df.setTimeZone(TimeZone.getTimeZone(this.TIMEZONE));
	        		Date dat = df.parse(sDate);
					if (date.after(dat)) break;
					
					// get link
					iStart = sLine.indexOf("?pid=") + 5;
					iEnd = sLine.indexOf("\"", iStart);
					URL url = new URL(this.IMAGE_URL + sLine.substring(iStart, iEnd));
					
					try {
						if (sLine.indexOf("images/folder.png") != -1) {
							// it's a folder
							TreeSet<GrabberImage> tmpSet = handleFolder(url, dat, sTargetUser);
							if (tmpSet == null) return null;
							set.addAll(tmpSet);
						} else {
							// it's an image
							GrabberImage g = handleImage(url, dat, sTargetUser);
							if (g == null) return null;
							set.add(g);
						}
					} catch (DownloadException e) {
						// just continue without loading this image/folder
						continue;
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			e.printStackTrace(Logwriter.getInstance().getPrintStream());
			String sMessage = e.getLocalizedMessage();
			if (sMessage == null) {
				sMessage = e.toString();
			} else {
				// remove url from message
				if (sMessage.lastIndexOf("http://") != -1) sMessage = sMessage.substring(0, sMessage.lastIndexOf("http://"));
				// remove everything after :
				if (sMessage.lastIndexOf(":") != -1) sMessage = sMessage.substring(0, sMessage.lastIndexOf(":"));
				String sClassdef = e.getClass().toString();
				sMessage = sClassdef.substring(sClassdef.indexOf("class ") + 6) + ((sMessage.length() == 0) ? "" : ": " + sMessage);
			}
			
			ErrorLogger.getInstance().addError(this.PAGENAME, sTargetUser, mainUrl.toString(), "Download failed: " + sMessage);
			throw null;
		}
		return set;
	}
	
	private GrabberImage handleImage(URL url, Date date, String sTargetUser) throws DownloadException {
		try {
			String sTitle = "";
			String sLocalpath = "";
			String sDescr = "";
			
			boolean bInComment = false;
			
			ArrayList<String> page = Downloader.downloadPage(url, null, null, 20000, 3);
			for (String sLine : page) {
				// title
				if (sLine.indexOf("<title>") != -1) {
					int iStart = sLine.indexOf("YIFFSTAR - the Yiffy Story Archive -- ") + 38;
					int iEnd = sLine.indexOf("</title>", iStart);
					sTitle = sLine.substring(iStart, iEnd);
					continue;
				}
				
				// image
				if (sLine.indexOf("<td align=\"center\"><a href=\"") != -1) {
					// image
					int iStart = sLine.indexOf("<td align=\"center\"><a href=\"") + 28;
					int iEnd = sLine.indexOf("\"", iStart);
					String imgPath = sLine.substring(iStart, iEnd);
					sLocalpath = this.m_ImageFolder + imgPath.substring(imgPath.lastIndexOf("/") + 1);
					sLocalpath = Downloader.downloadFile(new URL(imgPath), sLocalpath, null, null, 20000, 3);
				}
				
				//comment
				if (sLine.indexOf("?action=forceupload") != -1) {
					// comment (start)
					int iStart = sLine.indexOf("</center><br><br>") + 17;
					if (sLine.indexOf("</font>", iStart) != -1) {
						int iEnd = sLine.indexOf("</font>", iStart);
						sDescr = sLine.substring(iStart, iEnd);
						// can be empty
						break;
					}
					sDescr = sLine.substring(iStart);
					bInComment = true;
					continue;
				}
				
				if (bInComment) {
					if (sLine.indexOf("</font>") != -1) {
						int iEnd = sLine.indexOf("</font>");
						sDescr += sLine.substring(0, iEnd);
						break;
					}
					sDescr += sLine;
				}
			}
			return new GrabberImage(sLocalpath, sTitle, sDescr, date, url.toString());
		} catch (Exception e) {
			e.printStackTrace();
			e.printStackTrace(Logwriter.getInstance().getPrintStream());
			String sMessage = e.getLocalizedMessage();
			if (sMessage == null) {
				sMessage = e.toString();
			} else {
				// remove url from message
				if (sMessage.lastIndexOf("http://") != -1) sMessage = sMessage.substring(0, sMessage.lastIndexOf("http://"));
				// remove everything after :
				if (sMessage.lastIndexOf(":") != -1) sMessage = sMessage.substring(0, sMessage.lastIndexOf(":"));
				String sClassdef = e.getClass().toString();
				sMessage = sClassdef.substring(sClassdef.indexOf("class ") + 6) + ((sMessage.length() == 0) ? "" : ": " + sMessage);
			}
			
			ErrorLogger.getInstance().addError(this.PAGENAME, sTargetUser, url.toString(), "Download failed: " + sMessage);
			throw new DownloadException();
		}
	}
	
	private TreeSet<GrabberImage> handleFolder(URL url, Date date, String sTargetUser) throws DownloadException {
		TreeSet<GrabberImage> set = new TreeSet<GrabberImage>();
		try {
			ArrayList<String> page = Downloader.downloadPage(url, null, null, 20000, 3);
			boolean bCheck = false;
			for (String sLine : page) {
				if (!bCheck && sLine.indexOf("]<br></center>") != -1) {
					bCheck = true;
					sLine = sLine.substring(sLine.indexOf("]<br></center>") + 14);
				}
				if (bCheck && sLine.indexOf("]<br></center>") != -1){
					bCheck = false;
					
					// if there iis a next page, recursivity is at hand
					if (sLine.indexOf("\">Next Page</a>]") != -1) {
						int iEnd = sLine.indexOf("\">Next Page</a>]");
						int iStart = sLine.lastIndexOf("<a href=\"?pid=", iEnd);
						try {
							TreeSet<GrabberImage> tmpSet = handleFolder(new URL(this.IMAGE_URL + sLine.substring(iStart, iEnd)), date, sTargetUser);
							if (tmpSet == null) return null;
							set.addAll(tmpSet);
						} catch (DownloadException e) {
							// just continue without loading the next page
						}
					}
					break;
				}
				
				if (!bCheck) continue;
				
				if (sLine.indexOf("<a href=\"?pid=") != -1) {
					int iStart = sLine.indexOf("<a href=\"?pid=") + 14;
					int iEnd = sLine.indexOf("\"", iStart);
					URL newUrl = new URL(this.IMAGE_URL + sLine.substring(iStart, iEnd));
					
					try {
						if (sLine.indexOf("images/folder.png") != -1) {
							//its a folder
							TreeSet<GrabberImage> tmpset = handleFolder(newUrl, date, sTargetUser);
							if (tmpset == null) return null;
							set.addAll(tmpset);
						} else {
							// its an image
							GrabberImage img = handleImage(newUrl, date, sTargetUser);
							if (img == null) return null;
							set.add(img);
						}
					} catch (DownloadException e) {
						// just continue without loading this folder/image
						continue;
					}
				}
				
				
			}
			return set;
		} catch (Exception e) {
			e.printStackTrace();
			e.printStackTrace(Logwriter.getInstance().getPrintStream());
			String sMessage = e.getLocalizedMessage();
			if (sMessage == null) {
				sMessage = e.toString();
			} else {
				// remove url from message
				if (sMessage.lastIndexOf("http://") != -1) sMessage = sMessage.substring(0, sMessage.lastIndexOf("http://"));
				// remove everything after :
				if (sMessage.lastIndexOf(":") != -1) sMessage = sMessage.substring(0, sMessage.lastIndexOf(":"));
				String sClassdef = e.getClass().toString();
				sMessage = sClassdef.substring(sClassdef.indexOf("class ") + 6) + ((sMessage.length() == 0) ? "" : ": " + sMessage);
			}
			
			ErrorLogger.getInstance().addError(this.PAGENAME, sTargetUser, url.toString(), "Download failed: " + sMessage);
			throw new DownloadException();
		}
	}
}
